/*
	Copyright (c) 2004-2006, The Dojo Foundation
	All Rights Reserved.

	Licensed under the Academic Free License version 2.1 or above OR the
	modified BSD license. For more information on Dojo licensing, see:

		http://dojotoolkit.org/community/licensing.shtml
*/

/*
	This is a compiled version of Dojo, built for deployment and not for
	development. To get an editable version, please visit:

		http://dojotoolkit.org

	for documentation and information on getting the source.
*/

if(typeof dojo=="undefined"){
var dj_global=this;
var dj_currentContext=this;
function dj_undef(_1,_2){
return (typeof (_2||dj_currentContext)[_1]=="undefined");
}
if(dj_undef("djConfig",this)){
var djConfig={};
}
if(dj_undef("dojo",this)){
var dojo={};
}
dojo.global=function(){
return dj_currentContext;
};
dojo.locale=djConfig.locale;
dojo.version={major:0,minor:4,patch:4,flag:"",revision:Number("$Rev: 21543 $".match(/[0-9]+/)[0]),toString:function(){
with(dojo.version){
return major+"."+minor+"."+patch+flag+" ("+revision+")";
}
}};
dojo.evalProp=function(_3,_4,_5){
if((!_4)||(!_3)){
return undefined;
}
if(!dj_undef(_3,_4)){
return _4[_3];
}
return (_5?(_4[_3]={}):undefined);
};
dojo.parseObjPath=function(_6,_7,_8){
var _9=(_7||dojo.global());
var _a=_6.split(".");
var _b=_a.pop();
for(var i=0,l=_a.length;i<l&&_9;i++){
_9=dojo.evalProp(_a[i],_9,_8);
}
return {obj:_9,prop:_b};
};
dojo.evalObjPath=function(_e,_f){
if(typeof _e!="string"){
return dojo.global();
}
if(_e.indexOf(".")==-1){
return dojo.evalProp(_e,dojo.global(),_f);
}
var ref=dojo.parseObjPath(_e,dojo.global(),_f);
if(ref){
return dojo.evalProp(ref.prop,ref.obj,_f);
}
return null;
};
dojo.errorToString=function(_11){
if(!dj_undef("message",_11)){
return _11.message;
}else{
if(!dj_undef("description",_11)){
return _11.description;
}else{
return _11;
}
}
};
dojo.raise=function(_12,_13){
if(_13){
_12=_12+": "+dojo.errorToString(_13);
}else{
_12=dojo.errorToString(_12);
}
try{
if(djConfig.isDebug){
dojo.hostenv.println("FATAL exception raised: "+_12);
}
}
catch(e){
}
throw _13||Error(_12);
};
dojo.debug=function(){
};
dojo.debugShallow=function(obj){
};
dojo.profile={start:function(){
},end:function(){
},stop:function(){
},dump:function(){
}};
function dj_eval(_15){
return dj_global.eval?dj_global.eval(_15):eval(_15);
}
dojo.unimplemented=function(_16,_17){
var _18="'"+_16+"' not implemented";
if(_17!=null){
_18+=" "+_17;
}
dojo.raise(_18);
};
dojo.deprecated=function(_19,_1a,_1b){
var _1c="DEPRECATED: "+_19;
if(_1a){
_1c+=" "+_1a;
}
if(_1b){
_1c+=" -- will be removed in version: "+_1b;
}
dojo.debug(_1c);
};
dojo.render=(function(){
function vscaffold(_1d,_1e){
var tmp={capable:false,support:{builtin:false,plugin:false},prefixes:_1d};
for(var i=0;i<_1e.length;i++){
tmp[_1e[i]]=false;
}
return tmp;
}
return {name:"",ver:dojo.version,os:{win:false,linux:false,osx:false},html:vscaffold(["html"],["ie","opera","khtml","safari","moz"]),svg:vscaffold(["svg"],["corel","adobe","batik"]),vml:vscaffold(["vml"],["ie"]),swf:vscaffold(["Swf","Flash","Mm"],["mm"]),swt:vscaffold(["Swt"],["ibm"])};
})();
dojo.hostenv=(function(){
var _21={isDebug:false,allowQueryConfig:false,baseScriptUri:"",baseRelativePath:"",libraryScriptUri:"",iePreventClobber:false,ieClobberMinimal:true,preventBackButtonFix:true,delayMozLoadingFix:false,searchIds:[],parseWidgets:true};
if(typeof djConfig=="undefined"){
djConfig=_21;
}else{
for(var _22 in _21){
if(typeof djConfig[_22]=="undefined"){
djConfig[_22]=_21[_22];
}
}
}
return {name_:"(unset)",version_:"(unset)",getName:function(){
return this.name_;
},getVersion:function(){
return this.version_;
},getText:function(uri){
dojo.unimplemented("getText","uri="+uri);
}};
})();
dojo.hostenv.getBaseScriptUri=function(){
if(djConfig.baseScriptUri.length){
return djConfig.baseScriptUri;
}
var uri=new String(djConfig.libraryScriptUri||djConfig.baseRelativePath);
if(!uri){
dojo.raise("Nothing returned by getLibraryScriptUri(): "+uri);
}
var _25=uri.lastIndexOf("/");
djConfig.baseScriptUri=djConfig.baseRelativePath;
return djConfig.baseScriptUri;
};
(function(){
var _26={pkgFileName:"__package__",loading_modules_:{},loaded_modules_:{},addedToLoadingCount:[],removedFromLoadingCount:[],inFlightCount:0,modulePrefixes_:{dojo:{name:"dojo",value:"src"}},setModulePrefix:function(_27,_28){
this.modulePrefixes_[_27]={name:_27,value:_28};
},moduleHasPrefix:function(_29){
var mp=this.modulePrefixes_;
return Boolean(mp[_29]&&mp[_29].value);
},getModulePrefix:function(_2b){
if(this.moduleHasPrefix(_2b)){
return this.modulePrefixes_[_2b].value;
}
return _2b;
},getTextStack:[],loadUriStack:[],loadedUris:[],post_load_:false,modulesLoadedListeners:[],unloadListeners:[],loadNotifying:false};
for(var _2c in _26){
dojo.hostenv[_2c]=_26[_2c];
}
})();
dojo.hostenv.loadPath=function(_2d,_2e,cb){
var uri;
if(_2d.charAt(0)=="/"||_2d.match(/^\w+:/)){
uri=_2d;
}else{
uri=this.getBaseScriptUri()+_2d;
}
if(djConfig.cacheBust&&dojo.render.html.capable){
uri+="?"+String(djConfig.cacheBust).replace(/\W+/g,"");
}
try{
return !_2e?this.loadUri(uri,cb):this.loadUriAndCheck(uri,_2e,cb);
}
catch(e){
dojo.debug(e);
return false;
}
};
dojo.hostenv.loadUri=function(uri,cb){
if(this.loadedUris[uri]){
return true;
}
var _33=this.getText(uri,null,true);
if(!_33){
return false;
}
this.loadedUris[uri]=true;
if(cb){
_33="("+_33+")";
}
var _34=dj_eval(_33);
if(cb){
cb(_34);
}
return true;
};
dojo.hostenv.loadUriAndCheck=function(uri,_36,cb){
var ok=true;
try{
ok=this.loadUri(uri,cb);
}
catch(e){
dojo.debug("failed loading ",uri," with error: ",e);
}
return Boolean(ok&&this.findModule(_36,false));
};
dojo.loaded=function(){
};
dojo.unloaded=function(){
};
dojo.hostenv.loaded=function(){
this.loadNotifying=true;
this.post_load_=true;
var mll=this.modulesLoadedListeners;
for(var x=0;x<mll.length;x++){
mll[x]();
}
this.modulesLoadedListeners=[];
this.loadNotifying=false;
dojo.loaded();
};
dojo.hostenv.unloaded=function(){
var mll=this.unloadListeners;
while(mll.length){
(mll.pop())();
}
dojo.unloaded();
};
dojo.addOnLoad=function(obj,_3d){
var dh=dojo.hostenv;
if(arguments.length==1){
dh.modulesLoadedListeners.push(obj);
}else{
if(arguments.length>1){
dh.modulesLoadedListeners.push(function(){
obj[_3d]();
});
}
}
if(dh.post_load_&&dh.inFlightCount==0&&!dh.loadNotifying){
dh.callLoaded();
}
};
dojo.addOnUnload=function(obj,_40){
var dh=dojo.hostenv;
if(arguments.length==1){
dh.unloadListeners.push(obj);
}else{
if(arguments.length>1){
dh.unloadListeners.push(function(){
obj[_40]();
});
}
}
};
dojo.hostenv.modulesLoaded=function(){
if(this.post_load_){
return;
}
if(this.loadUriStack.length==0&&this.getTextStack.length==0){
if(this.inFlightCount>0){
dojo.debug("files still in flight!");
return;
}
dojo.hostenv.callLoaded();
}
};
dojo.hostenv.callLoaded=function(){
if(typeof setTimeout=="object"||(djConfig["useXDomain"]&&dojo.render.html.opera)){
setTimeout("dojo.hostenv.loaded();",0);
}else{
dojo.hostenv.loaded();
}
};
dojo.hostenv.getModuleSymbols=function(_42){
var _43=_42.split(".");
for(var i=_43.length;i>0;i--){
var _45=_43.slice(0,i).join(".");
if((i==1)&&!this.moduleHasPrefix(_45)){
_43[0]="../"+_43[0];
}else{
var _46=this.getModulePrefix(_45);
if(_46!=_45){
_43.splice(0,i,_46);
break;
}
}
}
return _43;
};
dojo.hostenv._global_omit_module_check=false;
dojo.hostenv.loadModule=function(_47,_48,_49){
if(!_47){
return;
}
_49=this._global_omit_module_check||_49;
var _4a=this.findModule(_47,false);
if(_4a){
return _4a;
}
if(dj_undef(_47,this.loading_modules_)){
this.addedToLoadingCount.push(_47);
}
this.loading_modules_[_47]=1;
var _4b=_47.replace(/\./g,"/")+".js";
var _4c=_47.split(".");
var _4d=this.getModuleSymbols(_47);
var _4e=((_4d[0].charAt(0)!="/")&&!_4d[0].match(/^\w+:/));
var _4f=_4d[_4d.length-1];
var ok;
if(_4f=="*"){
_47=_4c.slice(0,-1).join(".");
while(_4d.length){
_4d.pop();
_4d.push(this.pkgFileName);
_4b=_4d.join("/")+".js";
if(_4e&&_4b.charAt(0)=="/"){
_4b=_4b.slice(1);
}
ok=this.loadPath(_4b,!_49?_47:null);
if(ok){
break;
}
_4d.pop();
}
}else{
_4b=_4d.join("/")+".js";
_47=_4c.join(".");
var _51=!_49?_47:null;
ok=this.loadPath(_4b,_51);
if(!ok&&!_48){
_4d.pop();
while(_4d.length){
_4b=_4d.join("/")+".js";
ok=this.loadPath(_4b,_51);
if(ok){
break;
}
_4d.pop();
_4b=_4d.join("/")+"/"+this.pkgFileName+".js";
if(_4e&&_4b.charAt(0)=="/"){
_4b=_4b.slice(1);
}
ok=this.loadPath(_4b,_51);
if(ok){
break;
}
}
}
if(!ok&&!_49){
dojo.raise("Could not load '"+_47+"'; last tried '"+_4b+"'");
}
}
if(!_49&&!this["isXDomain"]){
_4a=this.findModule(_47,false);
if(!_4a){
dojo.raise("symbol '"+_47+"' is not defined after loading '"+_4b+"'");
}
}
return _4a;
};
dojo.hostenv.startPackage=function(_52){
var _53=String(_52);
var _54=_53;
var _55=_52.split(/\./);
if(_55[_55.length-1]=="*"){
_55.pop();
_54=_55.join(".");
}
var _56=dojo.evalObjPath(_54,true);
this.loaded_modules_[_53]=_56;
this.loaded_modules_[_54]=_56;
return _56;
};
dojo.hostenv.findModule=function(_57,_58){
var lmn=String(_57);
if(this.loaded_modules_[lmn]){
return this.loaded_modules_[lmn];
}
if(_58){
dojo.raise("no loaded module named '"+_57+"'");
}
return null;
};
dojo.kwCompoundRequire=function(_5a){
var _5b=_5a["common"]||[];
var _5c=_5a[dojo.hostenv.name_]?_5b.concat(_5a[dojo.hostenv.name_]||[]):_5b.concat(_5a["default"]||[]);
for(var x=0;x<_5c.length;x++){
var _5e=_5c[x];
if(_5e.constructor==Array){
dojo.hostenv.loadModule.apply(dojo.hostenv,_5e);
}else{
dojo.hostenv.loadModule(_5e);
}
}
};
dojo.require=function(_5f){
dojo.hostenv.loadModule.apply(dojo.hostenv,arguments);
};
dojo.requireIf=function(_60,_61){
var _62=arguments[0];
if((_62===true)||(_62=="common")||(_62&&dojo.render[_62].capable)){
var _63=[];
for(var i=1;i<arguments.length;i++){
_63.push(arguments[i]);
}
dojo.require.apply(dojo,_63);
}
};
dojo.requireAfterIf=dojo.requireIf;
dojo.provide=function(_65){
return dojo.hostenv.startPackage.apply(dojo.hostenv,arguments);
};
dojo.registerModulePath=function(_66,_67){
return dojo.hostenv.setModulePrefix(_66,_67);
};
if(djConfig["modulePaths"]){
for(var param in djConfig["modulePaths"]){
dojo.registerModulePath(param,djConfig["modulePaths"][param]);
}
}
dojo.setModulePrefix=function(_68,_69){
dojo.deprecated("dojo.setModulePrefix(\""+_68+"\", \""+_69+"\")","replaced by dojo.registerModulePath","0.5");
return dojo.registerModulePath(_68,_69);
};
dojo.exists=function(obj,_6b){
var p=_6b.split(".");
for(var i=0;i<p.length;i++){
if(!obj[p[i]]){
return false;
}
obj=obj[p[i]];
}
return true;
};
dojo.hostenv.normalizeLocale=function(_6e){
var _6f=_6e?_6e.toLowerCase():dojo.locale;
if(_6f=="root"){
_6f="ROOT";
}
return _6f;
};
dojo.hostenv.searchLocalePath=function(_70,_71,_72){
_70=dojo.hostenv.normalizeLocale(_70);
var _73=_70.split("-");
var _74=[];
for(var i=_73.length;i>0;i--){
_74.push(_73.slice(0,i).join("-"));
}
_74.push(false);
if(_71){
_74.reverse();
}
for(var j=_74.length-1;j>=0;j--){
var loc=_74[j]||"ROOT";
var _78=_72(loc);
if(_78){
break;
}
}
};
dojo.hostenv.localesGenerated;
dojo.hostenv.registerNlsPrefix=function(){
dojo.registerModulePath("nls","nls");
};
dojo.hostenv.preloadLocalizations=function(){
if(dojo.hostenv.localesGenerated){
dojo.hostenv.registerNlsPrefix();
function preload(_79){
_79=dojo.hostenv.normalizeLocale(_79);
dojo.hostenv.searchLocalePath(_79,true,function(loc){
for(var i=0;i<dojo.hostenv.localesGenerated.length;i++){
if(dojo.hostenv.localesGenerated[i]==loc){
dojo["require"]("nls.dojo_"+loc);
return true;
}
}
return false;
});
}
preload();
var _7c=djConfig.extraLocale||[];
for(var i=0;i<_7c.length;i++){
preload(_7c[i]);
}
}
dojo.hostenv.preloadLocalizations=function(){
};
};
dojo.requireLocalization=function(_7e,_7f,_80,_81){
dojo.hostenv.preloadLocalizations();
var _82=dojo.hostenv.normalizeLocale(_80);
var _83=[_7e,"nls",_7f].join(".");
var _84="";
if(_81){
var _85=_81.split(",");
for(var i=0;i<_85.length;i++){
if(_82.indexOf(_85[i])==0){
if(_85[i].length>_84.length){
_84=_85[i];
}
}
}
if(!_84){
_84="ROOT";
}
}
var _87=_81?_84:_82;
var _88=dojo.hostenv.findModule(_83);
var _89=null;
if(_88){
if(djConfig.localizationComplete&&_88._built){
return;
}
var _8a=_87.replace("-","_");
var _8b=_83+"."+_8a;
_89=dojo.hostenv.findModule(_8b);
}
if(!_89){
_88=dojo.hostenv.startPackage(_83);
var _8c=dojo.hostenv.getModuleSymbols(_7e);
var _8d=_8c.concat("nls").join("/");
var _8e;
dojo.hostenv.searchLocalePath(_87,_81,function(loc){
var _90=loc.replace("-","_");
var _91=_83+"."+_90;
var _92=false;
if(!dojo.hostenv.findModule(_91)){
dojo.hostenv.startPackage(_91);
var _93=[_8d];
if(loc!="ROOT"){
_93.push(loc);
}
_93.push(_7f);
var _94=_93.join("/")+".js";
_92=dojo.hostenv.loadPath(_94,null,function(_95){
var _96=function(){
};
_96.prototype=_8e;
_88[_90]=new _96();
for(var j in _95){
_88[_90][j]=_95[j];
}
});
}else{
_92=true;
}
if(_92&&_88[_90]){
_8e=_88[_90];
}else{
_88[_90]=_8e;
}
if(_81){
return true;
}
});
}
if(_81&&_82!=_84){
_88[_82.replace("-","_")]=_88[_84.replace("-","_")];
}
};
(function(){
var _98=djConfig.extraLocale;
if(_98){
if(!_98 instanceof Array){
_98=[_98];
}
var req=dojo.requireLocalization;
dojo.requireLocalization=function(m,b,_9c,_9d){
req(m,b,_9c,_9d);
if(_9c){
return;
}
for(var i=0;i<_98.length;i++){
req(m,b,_98[i],_9d);
}
};
}
})();
}
if(typeof window!="undefined"){
(function(){
if(djConfig.allowQueryConfig){
var _9f=document.location.toString();
var _a0=_9f.split("?",2);
if(_a0.length>1){
var _a1=_a0[1];
var _a2=_a1.split("&");
for(var x in _a2){
var sp=_a2[x].split("=");
if((sp[0].length>9)&&(sp[0].substr(0,9)=="djConfig.")){
var opt=sp[0].substr(9);
try{
djConfig[opt]=eval(sp[1]);
}
catch(e){
djConfig[opt]=sp[1];
}
}
}
}
}
if(((djConfig["baseScriptUri"]=="")||(djConfig["baseRelativePath"]==""))&&(document&&document.getElementsByTagName)){
var _a6=document.getElementsByTagName("script");
var _a7=/(__package__|dojo|bootstrap1)\.js([\?\.]|$)/i;
for(var i=0;i<_a6.length;i++){
var src=_a6[i].getAttribute("src");
if(!src){
continue;
}
var m=src.match(_a7);
if(m){
var _ab=src.substring(0,m.index);
if(src.indexOf("bootstrap1")>-1){
_ab+="../";
}
if(!this["djConfig"]){
djConfig={};
}
if(djConfig["baseScriptUri"]==""){
djConfig["baseScriptUri"]=_ab;
}
if(djConfig["baseRelativePath"]==""){
djConfig["baseRelativePath"]=_ab;
}
break;
}
}
}
var dr=dojo.render;
var drh=dojo.render.html;
var drs=dojo.render.svg;
var dua=(drh.UA=navigator.userAgent);
var dav=(drh.AV=navigator.appVersion);
var t=true;
var f=false;
drh.capable=t;
drh.support.builtin=t;
dr.ver=parseFloat(drh.AV);
dr.os.mac=dav.indexOf("Macintosh")>=0;
dr.os.win=dav.indexOf("Windows")>=0;
dr.os.linux=dav.indexOf("X11")>=0;
drh.opera=dua.indexOf("Opera")>=0;
drh.khtml=(dav.indexOf("Konqueror")>=0)||(dav.indexOf("Safari")>=0);
drh.safari=dav.indexOf("Safari")>=0;
var _b3=dua.indexOf("Gecko");
drh.mozilla=drh.moz=(_b3>=0)&&(!drh.khtml);
if(drh.mozilla){
drh.geckoVersion=dua.substring(_b3+6,_b3+14);
}
drh.ie=(document.all)&&(!drh.opera);
drh.ie50=drh.ie&&dav.indexOf("MSIE 5.0")>=0;
drh.ie55=drh.ie&&dav.indexOf("MSIE 5.5")>=0;
drh.ie60=drh.ie&&dav.indexOf("MSIE 6.0")>=0;
drh.ie70=drh.ie&&dav.indexOf("MSIE 7.0")>=0;
var cm=document["compatMode"];
drh.quirks=(cm=="BackCompat")||(cm=="QuirksMode")||drh.ie55||drh.ie50;
dojo.locale=dojo.locale||(drh.ie?navigator.userLanguage:navigator.language).toLowerCase();
dr.vml.capable=drh.ie;
drs.capable=f;
drs.support.plugin=f;
drs.support.builtin=f;
var _b5=window["document"];
var tdi=_b5["implementation"];
if(drh.ie&&(window.location.protocol=="file:")){
djConfig.ieForceActiveXXhr=true;
}
if((tdi)&&(tdi["hasFeature"])&&(tdi.hasFeature("org.w3c.dom.svg","1.0"))){
drs.capable=t;
drs.support.builtin=t;
drs.support.plugin=f;
}
if(drh.safari){
var tmp=dua.split("AppleWebKit/")[1];
var ver=parseFloat(tmp.split(" ")[0]);
if(ver>=420){
drs.capable=t;
drs.support.builtin=t;
drs.support.plugin=f;
}
}else{
}
})();
dojo.hostenv.startPackage("dojo.hostenv");
dojo.render.name=dojo.hostenv.name_="browser";
dojo.hostenv.searchIds=[];
dojo.hostenv._XMLHTTP_PROGIDS=["Msxml2.XMLHTTP","Microsoft.XMLHTTP","Msxml2.XMLHTTP.4.0"];
dojo.hostenv.getXmlhttpObject=function(){
var _b9=null;
var _ba=null;
if(!dojo.render.html.ie||!djConfig.ieForceActiveXXhr){
try{
_b9=new XMLHttpRequest();
}
catch(e){
}
}
if(!_b9){
for(var i=0;i<3;++i){
var _bc=dojo.hostenv._XMLHTTP_PROGIDS[i];
try{
_b9=new ActiveXObject(_bc);
}
catch(e){
_ba=e;
}
if(_b9){
dojo.hostenv._XMLHTTP_PROGIDS=[_bc];
break;
}
}
}
if(!_b9){
return dojo.raise("XMLHTTP not available",_ba);
}
return _b9;
};
dojo.hostenv._blockAsync=false;
dojo.hostenv.getText=function(uri,_be,_bf){
if(!_be){
this._blockAsync=true;
}
var _c0=this.getXmlhttpObject();
function isDocumentOk(_c1){
var _c2=_c1["status"];
return Boolean((!_c2)||((200<=_c2)&&(300>_c2))||(_c2==304));
}
if(_be){
var _c3=this,_c4=null,gbl=dojo.global();
var xhr=dojo.evalObjPath("dojo.io.XMLHTTPTransport");
_c0.onreadystatechange=function(){
if(_c4){
gbl.clearTimeout(_c4);
_c4=null;
}
if(_c3._blockAsync||(xhr&&xhr._blockAsync)){
_c4=gbl.setTimeout(function(){
_c0.onreadystatechange.apply(this);
},10);
}else{
if(4==_c0.readyState){
if(isDocumentOk(_c0)){
_be(_c0.responseText);
}
}
}
};
}
_c0.open("GET",uri,_be?true:false);
try{
_c0.send(null);
if(_be){
return null;
}
if(!isDocumentOk(_c0)){
var err=Error("Unable to load "+uri+" status:"+_c0.status);
err.status=_c0.status;
err.responseText=_c0.responseText;
throw err;
}
}
catch(e){
this._blockAsync=false;
if((_bf)&&(!_be)){
return null;
}else{
throw e;
}
}
this._blockAsync=false;
return _c0.responseText;
};
dojo.hostenv.defaultDebugContainerId="dojoDebug";
dojo.hostenv._println_buffer=[];
dojo.hostenv._println_safe=false;
dojo.hostenv.println=function(_c8){
if(!dojo.hostenv._println_safe){
dojo.hostenv._println_buffer.push(_c8);
}else{
try{
var _c9=document.getElementById(djConfig.debugContainerId?djConfig.debugContainerId:dojo.hostenv.defaultDebugContainerId);
if(!_c9){
_c9=dojo.body();
}
var div=document.createElement("div");
div.appendChild(document.createTextNode(_c8));
_c9.appendChild(div);
}
catch(e){
try{
document.write("<div>"+_c8+"</div>");
}
catch(e2){
window.status=_c8;
}
}
}
};
dojo.addOnLoad(function(){
dojo.hostenv._println_safe=true;
while(dojo.hostenv._println_buffer.length>0){
dojo.hostenv.println(dojo.hostenv._println_buffer.shift());
}
});
function dj_addNodeEvtHdlr(_cb,_cc,fp){
var _ce=_cb["on"+_cc]||function(){
};
_cb["on"+_cc]=function(){
fp.apply(_cb,arguments);
_ce.apply(_cb,arguments);
};
return true;
}
dojo.hostenv._djInitFired=false;
function dj_load_init(e){
dojo.hostenv._djInitFired=true;
var _d0=(e&&e.type)?e.type.toLowerCase():"load";
if(arguments.callee.initialized||(_d0!="domcontentloaded"&&_d0!="load")){
return;
}
arguments.callee.initialized=true;
if(typeof (_timer)!="undefined"){
clearInterval(_timer);
delete _timer;
}
var _d1=function(){
if(dojo.render.html.ie){
dojo.hostenv.makeWidgets();
}
};
if(dojo.hostenv.inFlightCount==0){
_d1();
dojo.hostenv.modulesLoaded();
}else{
dojo.hostenv.modulesLoadedListeners.unshift(_d1);
}
}
if(document.addEventListener){
if(dojo.render.html.opera||(dojo.render.html.moz&&(djConfig["enableMozDomContentLoaded"]===true))){
document.addEventListener("DOMContentLoaded",dj_load_init,null);
}
window.addEventListener("load",dj_load_init,null);
}
if(dojo.render.html.ie&&dojo.render.os.win){
document.attachEvent("onreadystatechange",function(e){
if(document.readyState=="complete"){
dj_load_init();
}
});
}
if(/(WebKit|khtml)/i.test(navigator.userAgent)){
var _timer=setInterval(function(){
if(/loaded|complete/.test(document.readyState)){
dj_load_init();
}
},10);
}
if(dojo.render.html.ie){
dj_addNodeEvtHdlr(window,"beforeunload",function(){
dojo.hostenv._unloading=true;
window.setTimeout(function(){
dojo.hostenv._unloading=false;
},0);
});
}
dj_addNodeEvtHdlr(window,"unload",function(){
dojo.hostenv.unloaded();
if((!dojo.render.html.ie)||(dojo.render.html.ie&&dojo.hostenv._unloading)){
dojo.hostenv.unloaded();
}
});
dojo.hostenv.makeWidgets=function(){
var _d3=[];
if(djConfig.searchIds&&djConfig.searchIds.length>0){
_d3=_d3.concat(djConfig.searchIds);
}
if(dojo.hostenv.searchIds&&dojo.hostenv.searchIds.length>0){
_d3=_d3.concat(dojo.hostenv.searchIds);
}
if((djConfig.parseWidgets)||(_d3.length>0)){
if(dojo.evalObjPath("dojo.widget.Parse")){
var _d4=new dojo.xml.Parse();
if(_d3.length>0){
for(var x=0;x<_d3.length;x++){
var _d6=document.getElementById(_d3[x]);
if(!_d6){
continue;
}
var _d7=_d4.parseElement(_d6,null,true);
dojo.widget.getParser().createComponents(_d7);
}
}else{
if(djConfig.parseWidgets){
var _d7=_d4.parseElement(dojo.body(),null,true);
dojo.widget.getParser().createComponents(_d7);
}
}
}
}
};
dojo.addOnLoad(function(){
if(!dojo.render.html.ie){
dojo.hostenv.makeWidgets();
}
});
try{
if(dojo.render.html.ie){
document.namespaces.add("v","urn:schemas-microsoft-com:vml");
document.createStyleSheet().addRule("v\\:*","behavior:url(#default#VML)");
}
}
catch(e){
}
dojo.hostenv.writeIncludes=function(){
};
if(!dj_undef("document",this)){
dj_currentDocument=this.document;
}
dojo.doc=function(){
return dj_currentDocument;
};
dojo.body=function(){
return dojo.doc().body||dojo.doc().getElementsByTagName("body")[0];
};
dojo.byId=function(id,doc){
if((id)&&((typeof id=="string")||(id instanceof String))){
if(!doc){
doc=dj_currentDocument;
}
var ele=doc.getElementById(id);
if(ele&&(ele.id!=id)&&doc.all){
ele=null;
eles=doc.all[id];
if(eles){
if(eles.length){
for(var i=0;i<eles.length;i++){
if(eles[i].id==id){
ele=eles[i];
break;
}
}
}else{
ele=eles;
}
}
}
return ele;
}
return id;
};
dojo.setContext=function(_dc,_dd){
dj_currentContext=_dc;
dj_currentDocument=_dd;
};
dojo._fireCallback=function(_de,_df,_e0){
if((_df)&&((typeof _de=="string")||(_de instanceof String))){
_de=_df[_de];
}
return (_df?_de.apply(_df,_e0||[]):_de());
};
dojo.withGlobal=function(_e1,_e2,_e3,_e4){
var _e5;
var _e6=dj_currentContext;
var _e7=dj_currentDocument;
try{
dojo.setContext(_e1,_e1.document);
_e5=dojo._fireCallback(_e2,_e3,_e4);
}
finally{
dojo.setContext(_e6,_e7);
}
return _e5;
};
dojo.withDoc=function(_e8,_e9,_ea,_eb){
var _ec;
var _ed=dj_currentDocument;
try{
dj_currentDocument=_e8;
_ec=dojo._fireCallback(_e9,_ea,_eb);
}
finally{
dj_currentDocument=_ed;
}
return _ec;
};
}
dojo.requireIf((djConfig["isDebug"]||djConfig["debugAtAllCosts"]),"dojo.debug");
dojo.requireIf(djConfig["debugAtAllCosts"]&&!window.widget&&!djConfig["useXDomain"],"dojo.browser_debug");
dojo.requireIf(djConfig["debugAtAllCosts"]&&!window.widget&&djConfig["useXDomain"],"dojo.browser_debug_xd");
dojo.provide("dojo.lang.common");
dojo.lang.inherits=function(_ee,_ef){
if(!dojo.lang.isFunction(_ef)){
dojo.raise("dojo.inherits: superclass argument ["+_ef+"] must be a function (subclass: ["+_ee+"']");
}
_ee.prototype=new _ef();
_ee.prototype.constructor=_ee;
_ee.superclass=_ef.prototype;
_ee["super"]=_ef.prototype;
};
dojo.lang._mixin=function(obj,_f1){
var _f2={};
for(var x in _f1){
if((typeof _f2[x]=="undefined")||(_f2[x]!=_f1[x])){
obj[x]=_f1[x];
}
}
if(dojo.render.html.ie&&(typeof (_f1["toString"])=="function")&&(_f1["toString"]!=obj["toString"])&&(_f1["toString"]!=_f2["toString"])){
obj.toString=_f1.toString;
}
return obj;
};
dojo.lang.mixin=function(obj,_f5){
for(var i=1,l=arguments.length;i<l;i++){
dojo.lang._mixin(obj,arguments[i]);
}
return obj;
};
dojo.lang.extend=function(_f8,_f9){
for(var i=1,l=arguments.length;i<l;i++){
dojo.lang._mixin(_f8.prototype,arguments[i]);
}
return _f8;
};
dojo.inherits=dojo.lang.inherits;
dojo.mixin=dojo.lang.mixin;
dojo.extend=dojo.lang.extend;
dojo.lang.find=function(_fc,_fd,_fe,_ff){
if(!dojo.lang.isArrayLike(_fc)&&dojo.lang.isArrayLike(_fd)){
dojo.deprecated("dojo.lang.find(value, array)","use dojo.lang.find(array, value) instead","0.5");
var temp=_fc;
_fc=_fd;
_fd=temp;
}
var _101=dojo.lang.isString(_fc);
if(_101){
_fc=_fc.split("");
}
if(_ff){
var step=-1;
var i=_fc.length-1;
var end=-1;
}else{
var step=1;
var i=0;
var end=_fc.length;
}
if(_fe){
while(i!=end){
if(_fc[i]===_fd){
return i;
}
i+=step;
}
}else{
while(i!=end){
if(_fc[i]==_fd){
return i;
}
i+=step;
}
}
return -1;
};
dojo.lang.indexOf=dojo.lang.find;
dojo.lang.findLast=function(_105,_106,_107){
return dojo.lang.find(_105,_106,_107,true);
};
dojo.lang.lastIndexOf=dojo.lang.findLast;
dojo.lang.inArray=function(_108,_109){
return dojo.lang.find(_108,_109)>-1;
};
dojo.lang.isObject=function(it){
if(typeof it=="undefined"){
return false;
}
return (typeof it=="object"||it===null||dojo.lang.isArray(it)||dojo.lang.isFunction(it));
};
dojo.lang.isArray=function(it){
return (it&&it instanceof Array||typeof it=="array");
};
dojo.lang.isArrayLike=function(it){
if((!it)||(dojo.lang.isUndefined(it))){
return false;
}
if(dojo.lang.isString(it)){
return false;
}
if(dojo.lang.isFunction(it)){
return false;
}
if(dojo.lang.isArray(it)){
return true;
}
if((it.tagName)&&(it.tagName.toLowerCase()=="form")){
return false;
}
if(dojo.lang.isNumber(it.length)&&isFinite(it.length)){
return true;
}
return false;
};
dojo.lang.isFunction=function(it){
return (it instanceof Function||typeof it=="function");
};
(function(){
if((dojo.render.html.capable)&&(dojo.render.html["safari"])){
dojo.lang.isFunction=function(it){
if((typeof (it)=="function")&&(it=="[object NodeList]")){
return false;
}
return (it instanceof Function||typeof it=="function");
};
}
})();
dojo.lang.isString=function(it){
return (typeof it=="string"||it instanceof String);
};
dojo.lang.isAlien=function(it){
if(!it){
return false;
}
return !dojo.lang.isFunction(it)&&/\{\s*\[native code\]\s*\}/.test(String(it));
};
dojo.lang.isBoolean=function(it){
return (it instanceof Boolean||typeof it=="boolean");
};
dojo.lang.isNumber=function(it){
return (it instanceof Number||typeof it=="number");
};
dojo.lang.isUndefined=function(it){
return ((typeof (it)=="undefined")&&(it==undefined));
};
dojo.provide("dojo.lang.array");
dojo.lang.mixin(dojo.lang,{has:function(obj,name){
try{
return typeof obj[name]!="undefined";
}
catch(e){
return false;
}
},isEmpty:function(obj){
if(dojo.lang.isObject(obj)){
var tmp={};
var _118=0;
for(var x in obj){
if(obj[x]&&(!tmp[x])){
_118++;
break;
}
}
return _118==0;
}else{
if(dojo.lang.isArrayLike(obj)||dojo.lang.isString(obj)){
return obj.length==0;
}
}
},map:function(arr,obj,_11c){
var _11d=dojo.lang.isString(arr);
if(_11d){
arr=arr.split("");
}
if(dojo.lang.isFunction(obj)&&(!_11c)){
_11c=obj;
obj=dj_global;
}else{
if(dojo.lang.isFunction(obj)&&_11c){
var _11e=obj;
obj=_11c;
_11c=_11e;
}
}
if(Array.map){
var _11f=Array.map(arr,_11c,obj);
}else{
var _11f=[];
for(var i=0;i<arr.length;++i){
_11f.push(_11c.call(obj,arr[i]));
}
}
if(_11d){
return _11f.join("");
}else{
return _11f;
}
},reduce:function(arr,_122,obj,_124){
var _125=_122;
if(arguments.length==2){
_124=_122;
_125=arr[0];
arr=arr.slice(1);
}else{
if(arguments.length==3){
if(dojo.lang.isFunction(obj)){
_124=obj;
obj=null;
}
}else{
if(dojo.lang.isFunction(obj)){
var tmp=_124;
_124=obj;
obj=tmp;
}
}
}
var ob=obj||dj_global;
dojo.lang.map(arr,function(val){
_125=_124.call(ob,_125,val);
});
return _125;
},forEach:function(_129,_12a,_12b){
if(dojo.lang.isString(_129)){
_129=_129.split("");
}
if(Array.forEach){
Array.forEach(_129,_12a,_12b);
}else{
if(!_12b){
_12b=dj_global;
}
for(var i=0,l=_129.length;i<l;i++){
_12a.call(_12b,_129[i],i,_129);
}
}
},_everyOrSome:function(_12e,arr,_130,_131){
if(dojo.lang.isString(arr)){
arr=arr.split("");
}
if(Array.every){
return Array[_12e?"every":"some"](arr,_130,_131);
}else{
if(!_131){
_131=dj_global;
}
for(var i=0,l=arr.length;i<l;i++){
var _134=_130.call(_131,arr[i],i,arr);
if(_12e&&!_134){
return false;
}else{
if((!_12e)&&(_134)){
return true;
}
}
}
return Boolean(_12e);
}
},every:function(arr,_136,_137){
return this._everyOrSome(true,arr,_136,_137);
},some:function(arr,_139,_13a){
return this._everyOrSome(false,arr,_139,_13a);
},filter:function(arr,_13c,_13d){
var _13e=dojo.lang.isString(arr);
if(_13e){
arr=arr.split("");
}
var _13f;
if(Array.filter){
_13f=Array.filter(arr,_13c,_13d);
}else{
if(!_13d){
if(arguments.length>=3){
dojo.raise("thisObject doesn't exist!");
}
_13d=dj_global;
}
_13f=[];
for(var i=0;i<arr.length;i++){
if(_13c.call(_13d,arr[i],i,arr)){
_13f.push(arr[i]);
}
}
}
if(_13e){
return _13f.join("");
}else{
return _13f;
}
},unnest:function(){
var out=[];
for(var i=0;i<arguments.length;i++){
if(dojo.lang.isArrayLike(arguments[i])){
var add=dojo.lang.unnest.apply(this,arguments[i]);
out=out.concat(add);
}else{
out.push(arguments[i]);
}
}
return out;
},toArray:function(_144,_145){
var _146=[];
for(var i=_145||0;i<_144.length;i++){
_146.push(_144[i]);
}
return _146;
}});
dojo.provide("dojo.gfx.color");
dojo.gfx.color.Color=function(r,g,b,a){
if(dojo.lang.isArray(r)){
this.r=r[0];
this.g=r[1];
this.b=r[2];
this.a=r[3]||1;
}else{
if(dojo.lang.isString(r)){
var rgb=dojo.gfx.color.extractRGB(r);
this.r=rgb[0];
this.g=rgb[1];
this.b=rgb[2];
this.a=g||1;
}else{
if(r instanceof dojo.gfx.color.Color){
this.r=r.r;
this.b=r.b;
this.g=r.g;
this.a=r.a;
}else{
this.r=r;
this.g=g;
this.b=b;
this.a=a;
}
}
}
};
dojo.gfx.color.Color.fromArray=function(arr){
return new dojo.gfx.color.Color(arr[0],arr[1],arr[2],arr[3]);
};
dojo.extend(dojo.gfx.color.Color,{toRgb:function(_14e){
if(_14e){
return this.toRgba();
}else{
return [this.r,this.g,this.b];
}
},toRgba:function(){
return [this.r,this.g,this.b,this.a];
},toHex:function(){
return dojo.gfx.color.rgb2hex(this.toRgb());
},toCss:function(){
return "rgb("+this.toRgb().join()+")";
},toString:function(){
return this.toHex();
},blend:function(_14f,_150){
var rgb=null;
if(dojo.lang.isArray(_14f)){
rgb=_14f;
}else{
if(_14f instanceof dojo.gfx.color.Color){
rgb=_14f.toRgb();
}else{
rgb=new dojo.gfx.color.Color(_14f).toRgb();
}
}
return dojo.gfx.color.blend(this.toRgb(),rgb,_150);
}});
dojo.gfx.color.named={white:[255,255,255],black:[0,0,0],red:[255,0,0],green:[0,255,0],lime:[0,255,0],blue:[0,0,255],navy:[0,0,128],gray:[128,128,128],silver:[192,192,192]};
dojo.gfx.color.blend=function(a,b,_154){
if(typeof a=="string"){
return dojo.gfx.color.blendHex(a,b,_154);
}
if(!_154){
_154=0;
}
_154=Math.min(Math.max(-1,_154),1);
_154=((_154+1)/2);
var c=[];
for(var x=0;x<3;x++){
c[x]=parseInt(b[x]+((a[x]-b[x])*_154));
}
return c;
};
dojo.gfx.color.blendHex=function(a,b,_159){
return dojo.gfx.color.rgb2hex(dojo.gfx.color.blend(dojo.gfx.color.hex2rgb(a),dojo.gfx.color.hex2rgb(b),_159));
};
dojo.gfx.color.extractRGB=function(_15a){
var hex="0123456789abcdef";
_15a=_15a.toLowerCase();
if(_15a.indexOf("rgb")==0){
var _15c=_15a.match(/rgba*\((\d+), *(\d+), *(\d+)/i);
var ret=_15c.splice(1,3);
return ret;
}else{
var _15e=dojo.gfx.color.hex2rgb(_15a);
if(_15e){
return _15e;
}else{
return dojo.gfx.color.named[_15a]||[255,255,255];
}
}
};
dojo.gfx.color.hex2rgb=function(hex){
var _160="0123456789ABCDEF";
var rgb=new Array(3);
if(hex.indexOf("#")==0){
hex=hex.substring(1);
}
hex=hex.toUpperCase();
if(hex.replace(new RegExp("["+_160+"]","g"),"")!=""){
return null;
}
if(hex.length==3){
rgb[0]=hex.charAt(0)+hex.charAt(0);
rgb[1]=hex.charAt(1)+hex.charAt(1);
rgb[2]=hex.charAt(2)+hex.charAt(2);
}else{
rgb[0]=hex.substring(0,2);
rgb[1]=hex.substring(2,4);
rgb[2]=hex.substring(4);
}
for(var i=0;i<rgb.length;i++){
rgb[i]=_160.indexOf(rgb[i].charAt(0))*16+_160.indexOf(rgb[i].charAt(1));
}
return rgb;
};
dojo.gfx.color.rgb2hex=function(r,g,b){
if(dojo.lang.isArray(r)){
g=r[1]||0;
b=r[2]||0;
r=r[0]||0;
}
var ret=dojo.lang.map([r,g,b],function(x){
x=new Number(x);
var s=x.toString(16);
while(s.length<2){
s="0"+s;
}
return s;
});
ret.unshift("#");
return ret.join("");
};
dojo.provide("dojo.lang.func");
dojo.lang.hitch=function(_169,_16a){
var args=[];
for(var x=2;x<arguments.length;x++){
args.push(arguments[x]);
}
var fcn=(dojo.lang.isString(_16a)?_169[_16a]:_16a)||function(){
};
return function(){
var ta=args.concat([]);
for(var x=0;x<arguments.length;x++){
ta.push(arguments[x]);
}
return fcn.apply(_169,ta);
};
};
dojo.lang.anonCtr=0;
dojo.lang.anon={};
dojo.lang.nameAnonFunc=function(_170,_171,_172){
var nso=(_171||dojo.lang.anon);
if((_172)||((dj_global["djConfig"])&&(djConfig["slowAnonFuncLookups"]==true))){
for(var x in nso){
try{
if(nso[x]===_170){
return x;
}
}
catch(e){
}
}
}
var ret="__"+dojo.lang.anonCtr++;
while(typeof nso[ret]!="undefined"){
ret="__"+dojo.lang.anonCtr++;
}
nso[ret]=_170;
return ret;
};
dojo.lang.forward=function(_176){
return function(){
return this[_176].apply(this,arguments);
};
};
dojo.lang.curry=function(_177,func){
var _179=[];
_177=_177||dj_global;
if(dojo.lang.isString(func)){
func=_177[func];
}
for(var x=2;x<arguments.length;x++){
_179.push(arguments[x]);
}
var _17b=(func["__preJoinArity"]||func.length)-_179.length;
function gather(_17c,_17d,_17e){
var _17f=_17e;
var _180=_17d.slice(0);
for(var x=0;x<_17c.length;x++){
_180.push(_17c[x]);
}
_17e=_17e-_17c.length;
if(_17e<=0){
var res=func.apply(_177,_180);
_17e=_17f;
return res;
}else{
return function(){
return gather(arguments,_180,_17e);
};
}
}
return gather([],_179,_17b);
};
dojo.lang.curryArguments=function(_183,func,args,_186){
var _187=[];
var x=_186||0;
for(x=_186;x<args.length;x++){
_187.push(args[x]);
}
return dojo.lang.curry.apply(dojo.lang,[_183,func].concat(_187));
};
dojo.lang.tryThese=function(){
for(var x=0;x<arguments.length;x++){
try{
if(typeof arguments[x]=="function"){
var ret=(arguments[x]());
if(ret){
return ret;
}
}
}
catch(e){
dojo.debug(e);
}
}
};
dojo.lang.delayThese=function(farr,cb,_18d,_18e){
if(!farr.length){
if(typeof _18e=="function"){
_18e();
}
return;
}
if((typeof _18d=="undefined")&&(typeof cb=="number")){
_18d=cb;
cb=function(){
};
}else{
if(!cb){
cb=function(){
};
if(!_18d){
_18d=0;
}
}
}
setTimeout(function(){
(farr.shift())();
cb();
dojo.lang.delayThese(farr,cb,_18d,_18e);
},_18d);
};
dojo.provide("dojo.lfx.Animation");
dojo.lfx.Line=function(_18f,end){
this.start=_18f;
this.end=end;
if(dojo.lang.isArray(_18f)){
var diff=[];
dojo.lang.forEach(this.start,function(s,i){
diff[i]=this.end[i]-s;
},this);
this.getValue=function(n){
var res=[];
dojo.lang.forEach(this.start,function(s,i){
res[i]=(diff[i]*n)+s;
},this);
return res;
};
}else{
var diff=end-_18f;
this.getValue=function(n){
return (diff*n)+this.start;
};
}
};
if((dojo.render.html.khtml)&&(!dojo.render.html.safari)){
dojo.lfx.easeDefault=function(n){
return (parseFloat("0.5")+((Math.sin((n+parseFloat("1.5"))*Math.PI))/2));
};
}else{
dojo.lfx.easeDefault=function(n){
return (0.5+((Math.sin((n+1.5)*Math.PI))/2));
};
}
dojo.lfx.easeIn=function(n){
return Math.pow(n,3);
};
dojo.lfx.easeOut=function(n){
return (1-Math.pow(1-n,3));
};
dojo.lfx.easeInOut=function(n){
return ((3*Math.pow(n,2))-(2*Math.pow(n,3)));
};
dojo.lfx.IAnimation=function(){
};
dojo.lang.extend(dojo.lfx.IAnimation,{curve:null,duration:1000,easing:null,repeatCount:0,rate:10,handler:null,beforeBegin:null,onBegin:null,onAnimate:null,onEnd:null,onPlay:null,onPause:null,onStop:null,play:null,pause:null,stop:null,connect:function(evt,_19f,_1a0){
if(!_1a0){
_1a0=_19f;
_19f=this;
}
_1a0=dojo.lang.hitch(_19f,_1a0);
var _1a1=this[evt]||function(){
};
this[evt]=function(){
var ret=_1a1.apply(this,arguments);
_1a0.apply(this,arguments);
return ret;
};
return this;
},fire:function(evt,args){
if(this[evt]){
this[evt].apply(this,(args||[]));
}
return this;
},repeat:function(_1a5){
this.repeatCount=_1a5;
return this;
},_active:false,_paused:false});
dojo.lfx.Animation=function(_1a6,_1a7,_1a8,_1a9,_1aa,rate){
dojo.lfx.IAnimation.call(this);
if(dojo.lang.isNumber(_1a6)||(!_1a6&&_1a7.getValue)){
rate=_1aa;
_1aa=_1a9;
_1a9=_1a8;
_1a8=_1a7;
_1a7=_1a6;
_1a6=null;
}else{
if(_1a6.getValue||dojo.lang.isArray(_1a6)){
rate=_1a9;
_1aa=_1a8;
_1a9=_1a7;
_1a8=_1a6;
_1a7=null;
_1a6=null;
}
}
if(dojo.lang.isArray(_1a8)){
this.curve=new dojo.lfx.Line(_1a8[0],_1a8[1]);
}else{
this.curve=_1a8;
}
if(_1a7!=null&&_1a7>0){
this.duration=_1a7;
}
if(_1aa){
this.repeatCount=_1aa;
}
if(rate){
this.rate=rate;
}
if(_1a6){
dojo.lang.forEach(["handler","beforeBegin","onBegin","onEnd","onPlay","onStop","onAnimate"],function(item){
if(_1a6[item]){
this.connect(item,_1a6[item]);
}
},this);
}
if(_1a9&&dojo.lang.isFunction(_1a9)){
this.easing=_1a9;
}
};
dojo.inherits(dojo.lfx.Animation,dojo.lfx.IAnimation);
dojo.lang.extend(dojo.lfx.Animation,{_startTime:null,_endTime:null,_timer:null,_percent:0,_startRepeatCount:0,play:function(_1ad,_1ae){
if(_1ae){
clearTimeout(this._timer);
this._active=false;
this._paused=false;
this._percent=0;
}else{
if(this._active&&!this._paused){
return this;
}
}
this.fire("handler",["beforeBegin"]);
this.fire("beforeBegin");
if(_1ad>0){
setTimeout(dojo.lang.hitch(this,function(){
this.play(null,_1ae);
}),_1ad);
return this;
}
this._startTime=new Date().valueOf();
if(this._paused){
this._startTime-=(this.duration*this._percent/100);
}
this._endTime=this._startTime+this.duration;
this._active=true;
this._paused=false;
var step=this._percent/100;
var _1b0=this.curve.getValue(step);
if(this._percent==0){
if(!this._startRepeatCount){
this._startRepeatCount=this.repeatCount;
}
this.fire("handler",["begin",_1b0]);
this.fire("onBegin",[_1b0]);
}
this.fire("handler",["play",_1b0]);
this.fire("onPlay",[_1b0]);
this._cycle();
return this;
},pause:function(){
clearTimeout(this._timer);
if(!this._active){
return this;
}
this._paused=true;
var _1b1=this.curve.getValue(this._percent/100);
this.fire("handler",["pause",_1b1]);
this.fire("onPause",[_1b1]);
return this;
},gotoPercent:function(pct,_1b3){
clearTimeout(this._timer);
this._active=true;
this._paused=true;
this._percent=pct;
if(_1b3){
this.play();
}
return this;
},stop:function(_1b4){
clearTimeout(this._timer);
var step=this._percent/100;
if(_1b4){
step=1;
}
var _1b6=this.curve.getValue(step);
this.fire("handler",["stop",_1b6]);
this.fire("onStop",[_1b6]);
this._active=false;
this._paused=false;
return this;
},status:function(){
if(this._active){
return this._paused?"paused":"playing";
}else{
return "stopped";
}
return this;
},_cycle:function(){
clearTimeout(this._timer);
if(this._active){
var curr=new Date().valueOf();
var step=(curr-this._startTime)/(this._endTime-this._startTime);
if(step>=1){
step=1;
this._percent=100;
}else{
this._percent=step*100;
}
if((this.easing)&&(dojo.lang.isFunction(this.easing))){
step=this.easing(step);
}
var _1b9=this.curve.getValue(step);
this.fire("handler",["animate",_1b9]);
this.fire("onAnimate",[_1b9]);
if(step<1){
this._timer=setTimeout(dojo.lang.hitch(this,"_cycle"),this.rate);
}else{
this._active=false;
this.fire("handler",["end"]);
this.fire("onEnd");
if(this.repeatCount>0){
this.repeatCount--;
this.play(null,true);
}else{
if(this.repeatCount==-1){
this.play(null,true);
}else{
if(this._startRepeatCount){
this.repeatCount=this._startRepeatCount;
this._startRepeatCount=0;
}
}
}
}
}
return this;
}});
dojo.lfx.Combine=function(_1ba){
dojo.lfx.IAnimation.call(this);
this._anims=[];
this._animsEnded=0;
var _1bb=arguments;
if(_1bb.length==1&&(dojo.lang.isArray(_1bb[0])||dojo.lang.isArrayLike(_1bb[0]))){
_1bb=_1bb[0];
}
dojo.lang.forEach(_1bb,function(anim){
this._anims.push(anim);
anim.connect("onEnd",dojo.lang.hitch(this,"_onAnimsEnded"));
},this);
};
dojo.inherits(dojo.lfx.Combine,dojo.lfx.IAnimation);
dojo.lang.extend(dojo.lfx.Combine,{_animsEnded:0,play:function(_1bd,_1be){
if(!this._anims.length){
return this;
}
this.fire("beforeBegin");
if(_1bd>0){
setTimeout(dojo.lang.hitch(this,function(){
this.play(null,_1be);
}),_1bd);
return this;
}
if(_1be||this._anims[0].percent==0){
this.fire("onBegin");
}
this.fire("onPlay");
this._animsCall("play",null,_1be);
return this;
},pause:function(){
this.fire("onPause");
this._animsCall("pause");
return this;
},stop:function(_1bf){
this.fire("onStop");
this._animsCall("stop",_1bf);
return this;
},_onAnimsEnded:function(){
this._animsEnded++;
if(this._animsEnded>=this._anims.length){
this.fire("onEnd");
}
return this;
},_animsCall:function(_1c0){
var args=[];
if(arguments.length>1){
for(var i=1;i<arguments.length;i++){
args.push(arguments[i]);
}
}
var _1c3=this;
dojo.lang.forEach(this._anims,function(anim){
anim[_1c0](args);
},_1c3);
return this;
}});
dojo.lfx.Chain=function(_1c5){
dojo.lfx.IAnimation.call(this);
this._anims=[];
this._currAnim=-1;
var _1c6=arguments;
if(_1c6.length==1&&(dojo.lang.isArray(_1c6[0])||dojo.lang.isArrayLike(_1c6[0]))){
_1c6=_1c6[0];
}
var _1c7=this;
dojo.lang.forEach(_1c6,function(anim,i,_1ca){
this._anims.push(anim);
if(i<_1ca.length-1){
anim.connect("onEnd",dojo.lang.hitch(this,"_playNext"));
}else{
anim.connect("onEnd",dojo.lang.hitch(this,function(){
this.fire("onEnd");
}));
}
},this);
};
dojo.inherits(dojo.lfx.Chain,dojo.lfx.IAnimation);
dojo.lang.extend(dojo.lfx.Chain,{_currAnim:-1,play:function(_1cb,_1cc){
if(!this._anims.length){
return this;
}
if(_1cc||!this._anims[this._currAnim]){
this._currAnim=0;
}
var _1cd=this._anims[this._currAnim];
this.fire("beforeBegin");
if(_1cb>0){
setTimeout(dojo.lang.hitch(this,function(){
this.play(null,_1cc);
}),_1cb);
return this;
}
if(_1cd){
if(this._currAnim==0){
this.fire("handler",["begin",this._currAnim]);
this.fire("onBegin",[this._currAnim]);
}
this.fire("onPlay",[this._currAnim]);
_1cd.play(null,_1cc);
}
return this;
},pause:function(){
if(this._anims[this._currAnim]){
this._anims[this._currAnim].pause();
this.fire("onPause",[this._currAnim]);
}
return this;
},playPause:function(){
if(this._anims.length==0){
return this;
}
if(this._currAnim==-1){
this._currAnim=0;
}
var _1ce=this._anims[this._currAnim];
if(_1ce){
if(!_1ce._active||_1ce._paused){
this.play();
}else{
this.pause();
}
}
return this;
},stop:function(){
var _1cf=this._anims[this._currAnim];
if(_1cf){
_1cf.stop();
this.fire("onStop",[this._currAnim]);
}
return _1cf;
},_playNext:function(){
if(this._currAnim==-1||this._anims.length==0){
return this;
}
this._currAnim++;
if(this._anims[this._currAnim]){
this._anims[this._currAnim].play(null,true);
}
return this;
}});
dojo.lfx.combine=function(_1d0){
var _1d1=arguments;
if(dojo.lang.isArray(arguments[0])){
_1d1=arguments[0];
}
if(_1d1.length==1){
return _1d1[0];
}
return new dojo.lfx.Combine(_1d1);
};
dojo.lfx.chain=function(_1d2){
var _1d3=arguments;
if(dojo.lang.isArray(arguments[0])){
_1d3=arguments[0];
}
if(_1d3.length==1){
return _1d3[0];
}
return new dojo.lfx.Chain(_1d3);
};
dojo.provide("dojo.dom");
dojo.dom.ELEMENT_NODE=1;
dojo.dom.ATTRIBUTE_NODE=2;
dojo.dom.TEXT_NODE=3;
dojo.dom.CDATA_SECTION_NODE=4;
dojo.dom.ENTITY_REFERENCE_NODE=5;
dojo.dom.ENTITY_NODE=6;
dojo.dom.PROCESSING_INSTRUCTION_NODE=7;
dojo.dom.COMMENT_NODE=8;
dojo.dom.DOCUMENT_NODE=9;
dojo.dom.DOCUMENT_TYPE_NODE=10;
dojo.dom.DOCUMENT_FRAGMENT_NODE=11;
dojo.dom.NOTATION_NODE=12;
dojo.dom.dojoml="http://www.dojotoolkit.org/2004/dojoml";
dojo.dom.xmlns={svg:"http://www.w3.org/2000/svg",smil:"http://www.w3.org/2001/SMIL20/",mml:"http://www.w3.org/1998/Math/MathML",cml:"http://www.xml-cml.org",xlink:"http://www.w3.org/1999/xlink",xhtml:"http://www.w3.org/1999/xhtml",xul:"http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul",xbl:"http://www.mozilla.org/xbl",fo:"http://www.w3.org/1999/XSL/Format",xsl:"http://www.w3.org/1999/XSL/Transform",xslt:"http://www.w3.org/1999/XSL/Transform",xi:"http://www.w3.org/2001/XInclude",xforms:"http://www.w3.org/2002/01/xforms",saxon:"http://icl.com/saxon",xalan:"http://xml.apache.org/xslt",xsd:"http://www.w3.org/2001/XMLSchema",dt:"http://www.w3.org/2001/XMLSchema-datatypes",xsi:"http://www.w3.org/2001/XMLSchema-instance",rdf:"http://www.w3.org/1999/02/22-rdf-syntax-ns#",rdfs:"http://www.w3.org/2000/01/rdf-schema#",dc:"http://purl.org/dc/elements/1.1/",dcq:"http://purl.org/dc/qualifiers/1.0","soap-env":"http://schemas.xmlsoap.org/soap/envelope/",wsdl:"http://schemas.xmlsoap.org/wsdl/",AdobeExtensions:"http://ns.adobe.com/AdobeSVGViewerExtensions/3.0/"};
dojo.dom.isNode=function(wh){
if(typeof Element=="function"){
try{
return wh instanceof Element;
}
catch(e){
}
}else{
return wh&&!isNaN(wh.nodeType);
}
};
dojo.dom.getUniqueId=function(){
var _1d5=dojo.doc();
do{
var id="dj_unique_"+(++arguments.callee._idIncrement);
}while(_1d5.getElementById(id));
return id;
};
dojo.dom.getUniqueId._idIncrement=0;
dojo.dom.firstElement=dojo.dom.getFirstChildElement=function(_1d7,_1d8){
var node=_1d7.firstChild;
while(node&&node.nodeType!=dojo.dom.ELEMENT_NODE){
node=node.nextSibling;
}
if(_1d8&&node&&node.tagName&&node.tagName.toLowerCase()!=_1d8.toLowerCase()){
node=dojo.dom.nextElement(node,_1d8);
}
return node;
};
dojo.dom.lastElement=dojo.dom.getLastChildElement=function(_1da,_1db){
var node=_1da.lastChild;
while(node&&node.nodeType!=dojo.dom.ELEMENT_NODE){
node=node.previousSibling;
}
if(_1db&&node&&node.tagName&&node.tagName.toLowerCase()!=_1db.toLowerCase()){
node=dojo.dom.prevElement(node,_1db);
}
return node;
};
dojo.dom.nextElement=dojo.dom.getNextSiblingElement=function(node,_1de){
if(!node){
return null;
}
do{
node=node.nextSibling;
}while(node&&node.nodeType!=dojo.dom.ELEMENT_NODE);
if(node&&_1de&&_1de.toLowerCase()!=node.tagName.toLowerCase()){
return dojo.dom.nextElement(node,_1de);
}
return node;
};
dojo.dom.prevElement=dojo.dom.getPreviousSiblingElement=function(node,_1e0){
if(!node){
return null;
}
if(_1e0){
_1e0=_1e0.toLowerCase();
}
do{
node=node.previousSibling;
}while(node&&node.nodeType!=dojo.dom.ELEMENT_NODE);
if(node&&_1e0&&_1e0.toLowerCase()!=node.tagName.toLowerCase()){
return dojo.dom.prevElement(node,_1e0);
}
return node;
};
dojo.dom.moveChildren=function(_1e1,_1e2,trim){
var _1e4=0;
if(trim){
while(_1e1.hasChildNodes()&&_1e1.firstChild.nodeType==dojo.dom.TEXT_NODE){
_1e1.removeChild(_1e1.firstChild);
}
while(_1e1.hasChildNodes()&&_1e1.lastChild.nodeType==dojo.dom.TEXT_NODE){
_1e1.removeChild(_1e1.lastChild);
}
}
while(_1e1.hasChildNodes()){
_1e2.appendChild(_1e1.firstChild);
_1e4++;
}
return _1e4;
};
dojo.dom.copyChildren=function(_1e5,_1e6,trim){
var _1e8=_1e5.cloneNode(true);
return this.moveChildren(_1e8,_1e6,trim);
};
dojo.dom.replaceChildren=function(node,_1ea){
var _1eb=[];
if(dojo.render.html.ie){
for(var i=0;i<node.childNodes.length;i++){
_1eb.push(node.childNodes[i]);
}
}
dojo.dom.removeChildren(node);
node.appendChild(_1ea);
for(var i=0;i<_1eb.length;i++){
dojo.dom.destroyNode(_1eb[i]);
}
};
dojo.dom.removeChildren=function(node){
var _1ee=node.childNodes.length;
while(node.hasChildNodes()){
dojo.dom.removeNode(node.firstChild);
}
return _1ee;
};
dojo.dom.replaceNode=function(node,_1f0){
return node.parentNode.replaceChild(_1f0,node);
};
dojo.dom.destroyNode=function(node){
if(node.parentNode){
node=dojo.dom.removeNode(node);
}
if(node.nodeType!=3){
if(dojo.evalObjPath("dojo.event.browser.clean",false)){
dojo.event.browser.clean(node);
}
if(dojo.render.html.ie){
node.outerHTML="";
}
}
};
dojo.dom.removeNode=function(node){
if(node&&node.parentNode){
return node.parentNode.removeChild(node);
}
};
dojo.dom.getAncestors=function(node,_1f4,_1f5){
var _1f6=[];
var _1f7=(_1f4&&(_1f4 instanceof Function||typeof _1f4=="function"));
while(node){
if(!_1f7||_1f4(node)){
_1f6.push(node);
}
if(_1f5&&_1f6.length>0){
return _1f6[0];
}
node=node.parentNode;
}
if(_1f5){
return null;
}
return _1f6;
};
dojo.dom.getAncestorsByTag=function(node,tag,_1fa){
tag=tag.toLowerCase();
return dojo.dom.getAncestors(node,function(el){
return ((el.tagName)&&(el.tagName.toLowerCase()==tag));
},_1fa);
};
dojo.dom.getFirstAncestorByTag=function(node,tag){
return dojo.dom.getAncestorsByTag(node,tag,true);
};
dojo.dom.isDescendantOf=function(node,_1ff,_200){
if(_200&&node){
node=node.parentNode;
}
while(node){
if(node==_1ff){
return true;
}
node=node.parentNode;
}
return false;
};
dojo.dom.innerXML=function(node){
if(node.innerXML){
return node.innerXML;
}else{
if(node.xml){
return node.xml;
}else{
if(typeof XMLSerializer!="undefined"){
return (new XMLSerializer()).serializeToString(node);
}
}
}
};
dojo.dom.createDocument=function(){
var doc=null;
var _203=dojo.doc();
if(!dj_undef("ActiveXObject")){
var _204=["MSXML2","Microsoft","MSXML","MSXML3"];
for(var i=0;i<_204.length;i++){
try{
doc=new ActiveXObject(_204[i]+".XMLDOM");
}
catch(e){
}
if(doc){
break;
}
}
}else{
if((_203.implementation)&&(_203.implementation.createDocument)){
doc=_203.implementation.createDocument("","",null);
}
}
return doc;
};
dojo.dom.createDocumentFromText=function(str,_207){
if(!_207){
_207="text/xml";
}
if(!dj_undef("DOMParser")){
var _208=new DOMParser();
return _208.parseFromString(str,_207);
}else{
if(!dj_undef("ActiveXObject")){
var _209=dojo.dom.createDocument();
if(_209){
_209.async=false;
_209.loadXML(str);
return _209;
}else{
dojo.debug("toXml didn't work?");
}
}else{
var _20a=dojo.doc();
if(_20a.createElement){
var tmp=_20a.createElement("xml");
tmp.innerHTML=str;
if(_20a.implementation&&_20a.implementation.createDocument){
var _20c=_20a.implementation.createDocument("foo","",null);
for(var i=0;i<tmp.childNodes.length;i++){
_20c.importNode(tmp.childNodes.item(i),true);
}
return _20c;
}
return ((tmp.document)&&(tmp.document.firstChild?tmp.document.firstChild:tmp));
}
}
}
return null;
};
dojo.dom.prependChild=function(node,_20f){
if(_20f.firstChild){
_20f.insertBefore(node,_20f.firstChild);
}else{
_20f.appendChild(node);
}
return true;
};
dojo.dom.insertBefore=function(node,ref,_212){
if((_212!=true)&&(node===ref||node.nextSibling===ref)){
return false;
}
var _213=ref.parentNode;
_213.insertBefore(node,ref);
return true;
};
dojo.dom.insertAfter=function(node,ref,_216){
var pn=ref.parentNode;
if(ref==pn.lastChild){
if((_216!=true)&&(node===ref)){
return false;
}
pn.appendChild(node);
}else{
return this.insertBefore(node,ref.nextSibling,_216);
}
return true;
};
dojo.dom.insertAtPosition=function(node,ref,_21a){
if((!node)||(!ref)||(!_21a)){
return false;
}
switch(_21a.toLowerCase()){
case "before":
return dojo.dom.insertBefore(node,ref);
case "after":
return dojo.dom.insertAfter(node,ref);
case "first":
if(ref.firstChild){
return dojo.dom.insertBefore(node,ref.firstChild);
}else{
ref.appendChild(node);
return true;
}
break;
default:
ref.appendChild(node);
return true;
}
};
dojo.dom.insertAtIndex=function(node,_21c,_21d){
var _21e=_21c.childNodes;
if(!_21e.length||_21e.length==_21d){
_21c.appendChild(node);
return true;
}
if(_21d==0){
return dojo.dom.prependChild(node,_21c);
}
return dojo.dom.insertAfter(node,_21e[_21d-1]);
};
dojo.dom.textContent=function(node,text){
if(arguments.length>1){
var _221=dojo.doc();
dojo.dom.replaceChildren(node,_221.createTextNode(text));
return text;
}else{
if(node.textContent!=undefined){
return node.textContent;
}
var _222="";
if(node==null){
return _222;
}
for(var i=0;i<node.childNodes.length;i++){
switch(node.childNodes[i].nodeType){
case 1:
case 5:
_222+=dojo.dom.textContent(node.childNodes[i]);
break;
case 3:
case 2:
case 4:
_222+=node.childNodes[i].nodeValue;
break;
default:
break;
}
}
return _222;
}
};
dojo.dom.hasParent=function(node){
return Boolean(node&&node.parentNode&&dojo.dom.isNode(node.parentNode));
};
dojo.dom.isTag=function(node){
if(node&&node.tagName){
for(var i=1;i<arguments.length;i++){
if(node.tagName==String(arguments[i])){
return String(arguments[i]);
}
}
}
return "";
};
dojo.dom.setAttributeNS=function(elem,_228,_229,_22a){
if(elem==null||((elem==undefined)&&(typeof elem=="undefined"))){
dojo.raise("No element given to dojo.dom.setAttributeNS");
}
if(!((elem.setAttributeNS==undefined)&&(typeof elem.setAttributeNS=="undefined"))){
elem.setAttributeNS(_228,_229,_22a);
}else{
var _22b=elem.ownerDocument;
var _22c=_22b.createNode(2,_229,_228);
_22c.nodeValue=_22a;
elem.setAttributeNode(_22c);
}
};
dojo.provide("dojo.html.common");
dojo.lang.mixin(dojo.html,dojo.dom);
dojo.html.body=function(){
dojo.deprecated("dojo.html.body() moved to dojo.body()","0.5");
return dojo.body();
};
dojo.html.getEventTarget=function(evt){
if(!evt){
evt=dojo.global().event||{};
}
var t=(evt.srcElement?evt.srcElement:(evt.target?evt.target:null));
while((t)&&(t.nodeType!=1)){
t=t.parentNode;
}
return t;
};
dojo.html.getViewport=function(){
var _22f=dojo.global();
var _230=dojo.doc();
var w=0;
var h=0;
if(dojo.render.html.mozilla){
w=_230.documentElement.clientWidth;
h=_22f.innerHeight;
}else{
if(!dojo.render.html.opera&&_22f.innerWidth){
w=_22f.innerWidth;
h=_22f.innerHeight;
}else{
if(!dojo.render.html.opera&&dojo.exists(_230,"documentElement.clientWidth")){
var w2=_230.documentElement.clientWidth;
if(!w||w2&&w2<w){
w=w2;
}
h=_230.documentElement.clientHeight;
}else{
if(dojo.body().clientWidth){
w=dojo.body().clientWidth;
h=dojo.body().clientHeight;
}
}
}
}
return {width:w,height:h};
};
dojo.html.getScroll=function(){
var _234=dojo.global();
var _235=dojo.doc();
var top=_234.pageYOffset||_235.documentElement.scrollTop||dojo.body().scrollTop||0;
var left=_234.pageXOffset||_235.documentElement.scrollLeft||dojo.body().scrollLeft||0;
return {top:top,left:left,offset:{x:left,y:top}};
};
dojo.html.getParentByType=function(node,type){
var _23a=dojo.doc();
var _23b=dojo.byId(node);
type=type.toLowerCase();
while((_23b)&&(_23b.nodeName.toLowerCase()!=type)){
if(_23b==(_23a["body"]||_23a["documentElement"])){
return null;
}
_23b=_23b.parentNode;
}
return _23b;
};
dojo.html.getAttribute=function(node,attr){
node=dojo.byId(node);
if((!node)||(!node.getAttribute)){
return null;
}
var ta=typeof attr=="string"?attr:new String(attr);
var v=node.getAttribute(ta.toUpperCase());
if((v)&&(typeof v=="string")&&(v!="")){
return v;
}
if(v&&v.value){
return v.value;
}
if((node.getAttributeNode)&&(node.getAttributeNode(ta))){
return (node.getAttributeNode(ta)).value;
}else{
if(node.getAttribute(ta)){
return node.getAttribute(ta);
}else{
if(node.getAttribute(ta.toLowerCase())){
return node.getAttribute(ta.toLowerCase());
}
}
}
return null;
};
dojo.html.hasAttribute=function(node,attr){
return dojo.html.getAttribute(dojo.byId(node),attr)?true:false;
};
dojo.html.getCursorPosition=function(e){
e=e||dojo.global().event;
var _243={x:0,y:0};
if(e.pageX||e.pageY){
_243.x=e.pageX;
_243.y=e.pageY;
}else{
var de=dojo.doc().documentElement;
var db=dojo.body();
_243.x=e.clientX+((de||db)["scrollLeft"])-((de||db)["clientLeft"]);
_243.y=e.clientY+((de||db)["scrollTop"])-((de||db)["clientTop"]);
}
return _243;
};
dojo.html.isTag=function(node){
node=dojo.byId(node);
if(node&&node.tagName){
for(var i=1;i<arguments.length;i++){
if(node.tagName.toLowerCase()==String(arguments[i]).toLowerCase()){
return String(arguments[i]).toLowerCase();
}
}
}
return "";
};
if(dojo.render.html.ie&&!dojo.render.html.ie70){
if(window.location.href.substr(0,6).toLowerCase()!="https:"){
(function(){
var _248=dojo.doc().createElement("script");
_248.src="javascript:'dojo.html.createExternalElement=function(doc, tag){ return doc.createElement(tag); }'";
dojo.doc().getElementsByTagName("head")[0].appendChild(_248);
})();
}
}else{
dojo.html.createExternalElement=function(doc,tag){
return doc.createElement(tag);
};
}
dojo.html._callDeprecated=function(_24b,_24c,args,_24e,_24f){
dojo.deprecated("dojo.html."+_24b,"replaced by dojo.html."+_24c+"("+(_24e?"node, {"+_24e+": "+_24e+"}":"")+")"+(_24f?"."+_24f:""),"0.5");
var _250=[];
if(_24e){
var _251={};
_251[_24e]=args[1];
_250.push(args[0]);
_250.push(_251);
}else{
_250=args;
}
var ret=dojo.html[_24c].apply(dojo.html,args);
if(_24f){
return ret[_24f];
}else{
return ret;
}
};
dojo.html.getViewportWidth=function(){
return dojo.html._callDeprecated("getViewportWidth","getViewport",arguments,null,"width");
};
dojo.html.getViewportHeight=function(){
return dojo.html._callDeprecated("getViewportHeight","getViewport",arguments,null,"height");
};
dojo.html.getViewportSize=function(){
return dojo.html._callDeprecated("getViewportSize","getViewport",arguments);
};
dojo.html.getScrollTop=function(){
return dojo.html._callDeprecated("getScrollTop","getScroll",arguments,null,"top");
};
dojo.html.getScrollLeft=function(){
return dojo.html._callDeprecated("getScrollLeft","getScroll",arguments,null,"left");
};
dojo.html.getScrollOffset=function(){
return dojo.html._callDeprecated("getScrollOffset","getScroll",arguments,null,"offset");
};
dojo.provide("dojo.uri.Uri");
dojo.uri=new function(){
this.dojoUri=function(uri){
return new dojo.uri.Uri(dojo.hostenv.getBaseScriptUri(),uri);
};
this.moduleUri=function(_254,uri){
var loc=dojo.hostenv.getModuleSymbols(_254).join("/");
if(!loc){
return null;
}
if(loc.lastIndexOf("/")!=loc.length-1){
loc+="/";
}
var _257=loc.indexOf(":");
var _258=loc.indexOf("/");
if(loc.charAt(0)!="/"&&(_257==-1||_257>_258)){
loc=dojo.hostenv.getBaseScriptUri()+loc;
}
return new dojo.uri.Uri(loc,uri);
};
this.Uri=function(){
var uri=arguments[0];
for(var i=1;i<arguments.length;i++){
if(!arguments[i]){
continue;
}
var _25b=new dojo.uri.Uri(arguments[i].toString());
var _25c=new dojo.uri.Uri(uri.toString());
if((_25b.path=="")&&(_25b.scheme==null)&&(_25b.authority==null)&&(_25b.query==null)){
if(_25b.fragment!=null){
_25c.fragment=_25b.fragment;
}
_25b=_25c;
}else{
if(_25b.scheme==null){
_25b.scheme=_25c.scheme;
if(_25b.authority==null){
_25b.authority=_25c.authority;
if(_25b.path.charAt(0)!="/"){
var path=_25c.path.substring(0,_25c.path.lastIndexOf("/")+1)+_25b.path;
var segs=path.split("/");
for(var j=0;j<segs.length;j++){
if(segs[j]=="."){
if(j==segs.length-1){
segs[j]="";
}else{
segs.splice(j,1);
j--;
}
}else{
if(j>0&&!(j==1&&segs[0]=="")&&segs[j]==".."&&segs[j-1]!=".."){
if(j==segs.length-1){
segs.splice(j,1);
segs[j-1]="";
}else{
segs.splice(j-1,2);
j-=2;
}
}
}
}
_25b.path=segs.join("/");
}
}
}
}
uri="";
if(_25b.scheme!=null){
uri+=_25b.scheme+":";
}
if(_25b.authority!=null){
uri+="//"+_25b.authority;
}
uri+=_25b.path;
if(_25b.query!=null){
uri+="?"+_25b.query;
}
if(_25b.fragment!=null){
uri+="#"+_25b.fragment;
}
}
this.uri=uri.toString();
var _260="^(([^:/?#]+):)?(//([^/?#]*))?([^?#]*)(\\?([^#]*))?(#(.*))?$";
var r=this.uri.match(new RegExp(_260));
this.scheme=r[2]||(r[1]?"":null);
this.authority=r[4]||(r[3]?"":null);
this.path=r[5];
this.query=r[7]||(r[6]?"":null);
this.fragment=r[9]||(r[8]?"":null);
if(this.authority!=null){
_260="^((([^:]+:)?([^@]+))@)?([^:]*)(:([0-9]+))?$";
r=this.authority.match(new RegExp(_260));
this.user=r[3]||null;
this.password=r[4]||null;
this.host=r[5];
this.port=r[7]||null;
}
this.toString=function(){
return this.uri;
};
};
};
dojo.provide("dojo.html.style");
dojo.html.getClass=function(node){
node=dojo.byId(node);
if(!node){
return "";
}
var cs="";
if(typeof node.className=="string"){
cs=node.className;
}else{
if(dojo.html.hasAttribute(node,"class")){
cs=dojo.html.getAttribute(node,"class");
}
}
return cs.replace(/^\s+|\s+$/g,"");
};
dojo.html.getClasses=function(node){
var c=dojo.html.getClass(node);
return (c=="")?[]:c.split(/\s+/g);
};
dojo.html.hasClass=function(node,_267){
return (new RegExp("(^|\\s+)"+_267+"(\\s+|$)")).test(dojo.html.getClass(node));
};
dojo.html.prependClass=function(node,_269){
_269+=" "+dojo.html.getClass(node);
return dojo.html.setClass(node,_269);
};
dojo.html.addClass=function(node,_26b){
if(dojo.html.hasClass(node,_26b)){
return false;
}
_26b=(dojo.html.getClass(node)+" "+_26b).replace(/^\s+|\s+$/g,"");
return dojo.html.setClass(node,_26b);
};
dojo.html.setClass=function(node,_26d){
node=dojo.byId(node);
var cs=new String(_26d);
try{
if(typeof node.className=="string"){
node.className=cs;
}else{
if(node.setAttribute){
node.setAttribute("class",_26d);
try{
node.className=cs;
}
catch(e){
}
}else{
return false;
}
}
}
catch(e){
dojo.debug("dojo.html.setClass() failed",e);
}
return true;
};
dojo.html.removeClass=function(node,_270,_271){
try{
if(!_271){
var _272=dojo.html.getClass(node).replace(new RegExp("(^|\\s+)"+_270+"(\\s+|$)"),"$1$2");
}else{
var _272=dojo.html.getClass(node).replace(_270,"");
}
dojo.html.setClass(node,_272);
}
catch(e){
dojo.debug("dojo.html.removeClass() failed",e);
}
return true;
};
dojo.html.replaceClass=function(node,_274,_275){
dojo.html.removeClass(node,_275);
dojo.html.addClass(node,_274);
};
dojo.html.classMatchType={ContainsAll:0,ContainsAny:1,IsOnly:2};
dojo.html.getElementsByClass=function(_276,_277,_278,_279,_27a){
_27a=false;
var _27b=dojo.doc();
_277=dojo.byId(_277)||_27b;
var _27c=_276.split(/\s+/g);
var _27d=[];
if(_279!=1&&_279!=2){
_279=0;
}
var _27e=new RegExp("(\\s|^)(("+_27c.join(")|(")+"))(\\s|$)");
var _27f=_27c.join(" ").length;
var _280=[];
if(!_27a&&_27b.evaluate){
var _281=".//"+(_278||"*")+"[contains(";
if(_279!=dojo.html.classMatchType.ContainsAny){
_281+="concat(' ',@class,' '), ' "+_27c.join(" ') and contains(concat(' ',@class,' '), ' ")+" ')";
if(_279==2){
_281+=" and string-length(@class)="+_27f+"]";
}else{
_281+="]";
}
}else{
_281+="concat(' ',@class,' '), ' "+_27c.join(" ') or contains(concat(' ',@class,' '), ' ")+" ')]";
}
var _282=_27b.evaluate(_281,_277,null,XPathResult.ANY_TYPE,null);
var _283=_282.iterateNext();
while(_283){
try{
_280.push(_283);
_283=_282.iterateNext();
}
catch(e){
break;
}
}
return _280;
}else{
if(!_278){
_278="*";
}
_280=_277.getElementsByTagName(_278);
var node,i=0;
outer:
while(node=_280[i++]){
var _286=dojo.html.getClasses(node);
if(_286.length==0){
continue outer;
}
var _287=0;
for(var j=0;j<_286.length;j++){
if(_27e.test(_286[j])){
if(_279==dojo.html.classMatchType.ContainsAny){
_27d.push(node);
continue outer;
}else{
_287++;
}
}else{
if(_279==dojo.html.classMatchType.IsOnly){
continue outer;
}
}
}
if(_287==_27c.length){
if((_279==dojo.html.classMatchType.IsOnly)&&(_287==_286.length)){
_27d.push(node);
}else{
if(_279==dojo.html.classMatchType.ContainsAll){
_27d.push(node);
}
}
}
}
return _27d;
}
};
dojo.html.getElementsByClassName=dojo.html.getElementsByClass;
dojo.html.toCamelCase=function(_289){
var arr=_289.split("-"),cc=arr[0];
for(var i=1;i<arr.length;i++){
cc+=arr[i].charAt(0).toUpperCase()+arr[i].substring(1);
}
return cc;
};
dojo.html.toSelectorCase=function(_28d){
return _28d.replace(/([A-Z])/g,"-$1").toLowerCase();
};
if(dojo.render.html.ie){
dojo.html.getComputedStyle=function(node,_28f,_290){
node=dojo.byId(node);
if(!node||!node.currentStyle){
return _290;
}
return node.currentStyle[dojo.html.toCamelCase(_28f)];
};
dojo.html.getComputedStyles=function(node){
return node.currentStyle;
};
}else{
dojo.html.getComputedStyle=function(node,_293,_294){
node=dojo.byId(node);
if(!node||!node.style){
return _294;
}
var s=document.defaultView.getComputedStyle(node,null);
return (s&&s[dojo.html.toCamelCase(_293)])||"";
};
dojo.html.getComputedStyles=function(node){
return document.defaultView.getComputedStyle(node,null);
};
}
dojo.html.getStyleProperty=function(node,_298){
node=dojo.byId(node);
return (node&&node.style?node.style[dojo.html.toCamelCase(_298)]:undefined);
};
dojo.html.getStyle=function(node,_29a){
var _29b=dojo.html.getStyleProperty(node,_29a);
return (_29b?_29b:dojo.html.getComputedStyle(node,_29a));
};
dojo.html.setStyle=function(node,_29d,_29e){
node=dojo.byId(node);
if(node&&node.style){
var _29f=dojo.html.toCamelCase(_29d);
node.style[_29f]=_29e;
}
};
dojo.html.setStyleText=function(_2a0,text){
try{
_2a0.style.cssText=text;
}
catch(e){
_2a0.setAttribute("style",text);
}
};
dojo.html.copyStyle=function(_2a2,_2a3){
if(!_2a3.style.cssText){
_2a2.setAttribute("style",_2a3.getAttribute("style"));
}else{
_2a2.style.cssText=_2a3.style.cssText;
}
dojo.html.addClass(_2a2,dojo.html.getClass(_2a3));
};
dojo.html.getUnitValue=function(node,_2a5,_2a6){
var s=dojo.html.getComputedStyle(node,_2a5);
if((!s)||((s=="auto")&&(_2a6))){
return {value:0,units:"px"};
}
var _2a8=s.match(/(\-?[\d.]+)([a-z%]*)/i);
if(!_2a8){
return dojo.html.getUnitValue.bad;
}
return {value:Number(_2a8[1]),units:_2a8[2].toLowerCase()};
};
dojo.html.getUnitValue.bad={value:NaN,units:""};
if(dojo.render.html.ie){
dojo.html.toPixelValue=function(_2a9,_2aa){
if(!_2aa){
return 0;
}
if(_2aa.slice(-2)=="px"){
return parseFloat(_2aa);
}
var _2ab=0;
with(_2a9){
var _2ac=style.left;
var _2ad=runtimeStyle.left;
runtimeStyle.left=currentStyle.left;
try{
style.left=_2aa||0;
_2ab=style.pixelLeft;
style.left=_2ac;
runtimeStyle.left=_2ad;
}
catch(e){
}
}
return _2ab;
};
}else{
dojo.html.toPixelValue=function(_2ae,_2af){
return (_2af&&(_2af.slice(-2)=="px")?parseFloat(_2af):0);
};
}
dojo.html.getPixelValue=function(node,_2b1,_2b2){
return dojo.html.toPixelValue(node,dojo.html.getComputedStyle(node,_2b1));
};
dojo.html.setPositivePixelValue=function(node,_2b4,_2b5){
if(isNaN(_2b5)){
return false;
}
node.style[_2b4]=Math.max(0,_2b5)+"px";
return true;
};
dojo.html.styleSheet=null;
dojo.html.insertCssRule=function(_2b6,_2b7,_2b8){
if(!dojo.html.styleSheet){
if(document.createStyleSheet){
dojo.html.styleSheet=document.createStyleSheet();
}else{
if(document.styleSheets[0]){
dojo.html.styleSheet=document.styleSheets[0];
}else{
return null;
}
}
}
if(arguments.length<3){
if(dojo.html.styleSheet.cssRules){
_2b8=dojo.html.styleSheet.cssRules.length;
}else{
if(dojo.html.styleSheet.rules){
_2b8=dojo.html.styleSheet.rules.length;
}else{
return null;
}
}
}
if(dojo.html.styleSheet.insertRule){
var rule=_2b6+" { "+_2b7+" }";
return dojo.html.styleSheet.insertRule(rule,_2b8);
}else{
if(dojo.html.styleSheet.addRule){
return dojo.html.styleSheet.addRule(_2b6,_2b7,_2b8);
}else{
return null;
}
}
};
dojo.html.removeCssRule=function(_2ba){
if(!dojo.html.styleSheet){
dojo.debug("no stylesheet defined for removing rules");
return false;
}
if(dojo.render.html.ie){
if(!_2ba){
_2ba=dojo.html.styleSheet.rules.length;
dojo.html.styleSheet.removeRule(_2ba);
}
}else{
if(document.styleSheets[0]){
if(!_2ba){
_2ba=dojo.html.styleSheet.cssRules.length;
}
dojo.html.styleSheet.deleteRule(_2ba);
}
}
return true;
};
dojo.html._insertedCssFiles=[];
dojo.html.insertCssFile=function(URI,doc,_2bd,_2be){
if(!URI){
return;
}
if(!doc){
doc=document;
}
var _2bf=dojo.hostenv.getText(URI,false,_2be);
if(_2bf===null){
return;
}
_2bf=dojo.html.fixPathsInCssText(_2bf,URI);
if(_2bd){
var idx=-1,node,ent=dojo.html._insertedCssFiles;
for(var i=0;i<ent.length;i++){
if((ent[i].doc==doc)&&(ent[i].cssText==_2bf)){
idx=i;
node=ent[i].nodeRef;
break;
}
}
if(node){
var _2c4=doc.getElementsByTagName("style");
for(var i=0;i<_2c4.length;i++){
if(_2c4[i]==node){
return;
}
}
dojo.html._insertedCssFiles.shift(idx,1);
}
}
var _2c5=dojo.html.insertCssText(_2bf,doc);
dojo.html._insertedCssFiles.push({"doc":doc,"cssText":_2bf,"nodeRef":_2c5});
if(_2c5&&djConfig.isDebug){
_2c5.setAttribute("dbgHref",URI);
}
return _2c5;
};
dojo.html.insertCssText=function(_2c6,doc,URI){
if(!_2c6){
return;
}
if(!doc){
doc=document;
}
if(URI){
_2c6=dojo.html.fixPathsInCssText(_2c6,URI);
}
var _2c9=doc.createElement("style");
_2c9.setAttribute("type","text/css");
var head=doc.getElementsByTagName("head")[0];
if(!head){
dojo.debug("No head tag in document, aborting styles");
return;
}else{
head.appendChild(_2c9);
}
if(_2c9.styleSheet){
var _2cb=function(){
try{
_2c9.styleSheet.cssText=_2c6;
}
catch(e){
dojo.debug(e);
}
};
if(_2c9.styleSheet.disabled){
setTimeout(_2cb,10);
}else{
_2cb();
}
}else{
var _2cc=doc.createTextNode(_2c6);
_2c9.appendChild(_2cc);
}
return _2c9;
};
dojo.html.fixPathsInCssText=function(_2cd,URI){
if(!_2cd||!URI){
return;
}
var _2cf,str="",url="",_2d2="[\\t\\s\\w\\(\\)\\/\\.\\\\'\"-:#=&?~]+";
var _2d3=new RegExp("url\\(\\s*("+_2d2+")\\s*\\)");
var _2d4=/(file|https?|ftps?):\/\//;
regexTrim=new RegExp("^[\\s]*(['\"]?)("+_2d2+")\\1[\\s]*?$");
if(dojo.render.html.ie55||dojo.render.html.ie60){
var _2d5=new RegExp("AlphaImageLoader\\((.*)src=['\"]("+_2d2+")['\"]");
while(_2cf=_2d5.exec(_2cd)){
url=_2cf[2].replace(regexTrim,"$2");
if(!_2d4.exec(url)){
url=(new dojo.uri.Uri(URI,url).toString());
}
str+=_2cd.substring(0,_2cf.index)+"AlphaImageLoader("+_2cf[1]+"src='"+url+"'";
_2cd=_2cd.substr(_2cf.index+_2cf[0].length);
}
_2cd=str+_2cd;
str="";
}
while(_2cf=_2d3.exec(_2cd)){
url=_2cf[1].replace(regexTrim,"$2");
if(!_2d4.exec(url)){
url=(new dojo.uri.Uri(URI,url).toString());
}
str+=_2cd.substring(0,_2cf.index)+"url("+url+")";
_2cd=_2cd.substr(_2cf.index+_2cf[0].length);
}
return str+_2cd;
};
dojo.html.setActiveStyleSheet=function(_2d6){
var i=0,a,els=dojo.doc().getElementsByTagName("link");
while(a=els[i++]){
if(a.getAttribute("rel").indexOf("style")!=-1&&a.getAttribute("title")){
a.disabled=true;
if(a.getAttribute("title")==_2d6){
a.disabled=false;
}
}
}
};
dojo.html.getActiveStyleSheet=function(){
var i=0,a,els=dojo.doc().getElementsByTagName("link");
while(a=els[i++]){
if(a.getAttribute("rel").indexOf("style")!=-1&&a.getAttribute("title")&&!a.disabled){
return a.getAttribute("title");
}
}
return null;
};
dojo.html.getPreferredStyleSheet=function(){
var i=0,a,els=dojo.doc().getElementsByTagName("link");
while(a=els[i++]){
if(a.getAttribute("rel").indexOf("style")!=-1&&a.getAttribute("rel").indexOf("alt")==-1&&a.getAttribute("title")){
return a.getAttribute("title");
}
}
return null;
};
dojo.html.applyBrowserClass=function(node){
var drh=dojo.render.html;
var _2e2={dj_ie:drh.ie,dj_ie55:drh.ie55,dj_ie6:drh.ie60,dj_ie7:drh.ie70,dj_iequirks:drh.ie&&drh.quirks,dj_opera:drh.opera,dj_opera8:drh.opera&&(Math.floor(dojo.render.version)==8),dj_opera9:drh.opera&&(Math.floor(dojo.render.version)==9),dj_khtml:drh.khtml,dj_safari:drh.safari,dj_gecko:drh.mozilla};
for(var p in _2e2){
if(_2e2[p]){
dojo.html.addClass(node,p);
}
}
};
dojo.provide("dojo.html.display");
dojo.html._toggle=function(node,_2e5,_2e6){
node=dojo.byId(node);
_2e6(node,!_2e5(node));
return _2e5(node);
};
dojo.html.show=function(node){
node=dojo.byId(node);
if(dojo.html.getStyleProperty(node,"display")=="none"){
dojo.html.setStyle(node,"display",(node.dojoDisplayCache||""));
node.dojoDisplayCache=undefined;
}
};
dojo.html.hide=function(node){
node=dojo.byId(node);
if(typeof node["dojoDisplayCache"]=="undefined"){
var d=dojo.html.getStyleProperty(node,"display");
if(d!="none"){
node.dojoDisplayCache=d;
}
}
dojo.html.setStyle(node,"display","none");
};
dojo.html.setShowing=function(node,_2eb){
dojo.html[(_2eb?"show":"hide")](node);
};
dojo.html.isShowing=function(node){
return (dojo.html.getStyleProperty(node,"display")!="none");
};
dojo.html.toggleShowing=function(node){
return dojo.html._toggle(node,dojo.html.isShowing,dojo.html.setShowing);
};
dojo.html.displayMap={tr:"",td:"",th:"",img:"inline",span:"inline",input:"inline",button:"inline"};
dojo.html.suggestDisplayByTagName=function(node){
node=dojo.byId(node);
if(node&&node.tagName){
var tag=node.tagName.toLowerCase();
return (tag in dojo.html.displayMap?dojo.html.displayMap[tag]:"block");
}
};
dojo.html.setDisplay=function(node,_2f1){
dojo.html.setStyle(node,"display",((_2f1 instanceof String||typeof _2f1=="string")?_2f1:(_2f1?dojo.html.suggestDisplayByTagName(node):"none")));
};
dojo.html.isDisplayed=function(node){
return (dojo.html.getComputedStyle(node,"display")!="none");
};
dojo.html.toggleDisplay=function(node){
return dojo.html._toggle(node,dojo.html.isDisplayed,dojo.html.setDisplay);
};
dojo.html.setVisibility=function(node,_2f5){
dojo.html.setStyle(node,"visibility",((_2f5 instanceof String||typeof _2f5=="string")?_2f5:(_2f5?"visible":"hidden")));
};
dojo.html.isVisible=function(node){
return (dojo.html.getComputedStyle(node,"visibility")!="hidden");
};
dojo.html.toggleVisibility=function(node){
return dojo.html._toggle(node,dojo.html.isVisible,dojo.html.setVisibility);
};
dojo.html.setOpacity=function(node,_2f9,_2fa){
node=dojo.byId(node);
var h=dojo.render.html;
if(!_2fa){
if(_2f9>=1){
if(h.ie){
dojo.html.clearOpacity(node);
return;
}else{
_2f9=0.999999;
}
}else{
if(_2f9<0){
_2f9=0;
}
}
}
if(h.ie){
if(node.nodeName.toLowerCase()=="tr"){
var tds=node.getElementsByTagName("td");
for(var x=0;x<tds.length;x++){
tds[x].style.filter="Alpha(Opacity="+_2f9*100+")";
}
}
node.style.filter="Alpha(Opacity="+_2f9*100+")";
}else{
if(h.moz){
node.style.opacity=_2f9;
node.style.MozOpacity=_2f9;
}else{
if(h.safari){
node.style.opacity=_2f9;
node.style.KhtmlOpacity=_2f9;
}else{
node.style.opacity=_2f9;
}
}
}
};
dojo.html.clearOpacity=function(node){
node=dojo.byId(node);
var ns=node.style;
var h=dojo.render.html;
if(h.ie){
try{
if(node.filters&&node.filters.alpha){
ns.filter="";
}
}
catch(e){
}
}else{
if(h.moz){
ns.opacity=1;
ns.MozOpacity=1;
}else{
if(h.safari){
ns.opacity=1;
ns.KhtmlOpacity=1;
}else{
ns.opacity=1;
}
}
}
};
dojo.html.getOpacity=function(node){
node=dojo.byId(node);
var h=dojo.render.html;
if(h.ie){
var opac=(node.filters&&node.filters.alpha&&typeof node.filters.alpha.opacity=="number"?node.filters.alpha.opacity:100)/100;
}else{
var opac=node.style.opacity||node.style.MozOpacity||node.style.KhtmlOpacity||1;
}
return opac>=0.999999?1:Number(opac);
};
dojo.provide("dojo.html.color");
dojo.html.getBackgroundColor=function(node){
node=dojo.byId(node);
var _305;
do{
_305=dojo.html.getStyle(node,"background-color");
if(_305.toLowerCase()=="rgba(0, 0, 0, 0)"){
_305="transparent";
}
if(node==document.getElementsByTagName("body")[0]){
node=null;
break;
}
node=node.parentNode;
}while(node&&dojo.lang.inArray(["transparent",""],_305));
if(_305=="transparent"){
_305=[255,255,255,0];
}else{
_305=dojo.gfx.color.extractRGB(_305);
}
return _305;
};
dojo.provide("dojo.html.layout");
dojo.html.sumAncestorProperties=function(node,prop){
node=(dojo.byId(node)||0).parentNode;
if(!node){
return 0;
}
var _308=0;
while(node){
if(dojo.html.getComputedStyle(node,"position")=="fixed"){
return 0;
}
var val=node[prop];
if(val){
_308+=val-0;
if(node==dojo.body()){
break;
}
}
node=node.parentNode;
}
return _308;
};
dojo.html.setStyleAttributes=function(node,_30b){
node=dojo.byId(node);
var _30c=_30b.replace(/(;)?\s*$/,"").split(";");
for(var i=0;i<_30c.length;i++){
var _30e=_30c[i].split(":");
var name=_30e[0].replace(/\s*$/,"").replace(/^\s*/,"").toLowerCase();
var _310=_30e[1].replace(/\s*$/,"").replace(/^\s*/,"");
switch(name){
case "opacity":
dojo.html.setOpacity(node,_310);
break;
case "content-height":
dojo.html.setContentBox(node,{height:_310});
break;
case "content-width":
dojo.html.setContentBox(node,{width:_310});
break;
case "outer-height":
dojo.html.setMarginBox(node,{height:_310});
break;
case "outer-width":
dojo.html.setMarginBox(node,{width:_310});
break;
default:
node.style[dojo.html.toCamelCase(name)]=_310;
}
}
};
dojo.html.boxSizing={MARGIN_BOX:"margin-box",BORDER_BOX:"border-box",PADDING_BOX:"padding-box",CONTENT_BOX:"content-box"};
dojo.html.getAbsolutePosition=dojo.html.abs=function(node,_312,_313){
node=dojo.byId(node,node.ownerDocument);
var ret={x:0,y:0};
var bs=dojo.html.boxSizing;
if(!_313){
_313=bs.CONTENT_BOX;
}
var _316=2;
var _317;
switch(_313){
case bs.MARGIN_BOX:
_317=3;
break;
case bs.BORDER_BOX:
_317=2;
break;
case bs.PADDING_BOX:
default:
_317=1;
break;
case bs.CONTENT_BOX:
_317=0;
break;
}
var h=dojo.render.html;
var db=document["body"]||document["documentElement"];
if(h.ie){
with(node.getBoundingClientRect()){
ret.x=left-2;
ret.y=top-2;
}
}else{
if(document.getBoxObjectFor){
_316=1;
try{
var bo=document.getBoxObjectFor(node);
ret.x=bo.x-dojo.html.sumAncestorProperties(node,"scrollLeft");
ret.y=bo.y-dojo.html.sumAncestorProperties(node,"scrollTop");
}
catch(e){
}
}else{
if(node["offsetParent"]){
var _31b;
if((h.safari)&&(node.style.getPropertyValue("position")=="absolute")&&(node.parentNode==db)){
_31b=db;
}else{
_31b=db.parentNode;
}
if(node.parentNode!=db){
var nd=node;
if(dojo.render.html.opera){
nd=db;
}
ret.x-=dojo.html.sumAncestorProperties(nd,"scrollLeft");
ret.y-=dojo.html.sumAncestorProperties(nd,"scrollTop");
}
var _31d=node;
do{
var n=_31d["offsetLeft"];
if(!h.opera||n>0){
ret.x+=isNaN(n)?0:n;
}
var m=_31d["offsetTop"];
ret.y+=isNaN(m)?0:m;
_31d=_31d.offsetParent;
}while((_31d!=_31b)&&(_31d!=null));
}else{
if(node["x"]&&node["y"]){
ret.x+=isNaN(node.x)?0:node.x;
ret.y+=isNaN(node.y)?0:node.y;
}
}
}
}
if(_312){
var _320=dojo.html.getScroll();
ret.y+=_320.top;
ret.x+=_320.left;
}
var _321=[dojo.html.getPaddingExtent,dojo.html.getBorderExtent,dojo.html.getMarginExtent];
if(_316>_317){
for(var i=_317;i<_316;++i){
ret.y+=_321[i](node,"top");
ret.x+=_321[i](node,"left");
}
}else{
if(_316<_317){
for(var i=_317;i>_316;--i){
ret.y-=_321[i-1](node,"top");
ret.x-=_321[i-1](node,"left");
}
}
}
ret.top=ret.y;
ret.left=ret.x;
return ret;
};
dojo.html.isPositionAbsolute=function(node){
return (dojo.html.getComputedStyle(node,"position")=="absolute");
};
dojo.html._sumPixelValues=function(node,_325,_326){
var _327=0;
for(var x=0;x<_325.length;x++){
_327+=dojo.html.getPixelValue(node,_325[x],_326);
}
return _327;
};
dojo.html.getMargin=function(node){
return {width:dojo.html._sumPixelValues(node,["margin-left","margin-right"],(dojo.html.getComputedStyle(node,"position")=="absolute")),height:dojo.html._sumPixelValues(node,["margin-top","margin-bottom"],(dojo.html.getComputedStyle(node,"position")=="absolute"))};
};
dojo.html.getBorder=function(node){
return {width:dojo.html.getBorderExtent(node,"left")+dojo.html.getBorderExtent(node,"right"),height:dojo.html.getBorderExtent(node,"top")+dojo.html.getBorderExtent(node,"bottom")};
};
dojo.html.getBorderExtent=function(node,side){
return (dojo.html.getStyle(node,"border-"+side+"-style")=="none"?0:dojo.html.getPixelValue(node,"border-"+side+"-width"));
};
dojo.html.getMarginExtent=function(node,side){
return dojo.html._sumPixelValues(node,["margin-"+side],dojo.html.isPositionAbsolute(node));
};
dojo.html.getPaddingExtent=function(node,side){
return dojo.html._sumPixelValues(node,["padding-"+side],true);
};
dojo.html.getPadding=function(node){
return {width:dojo.html._sumPixelValues(node,["padding-left","padding-right"],true),height:dojo.html._sumPixelValues(node,["padding-top","padding-bottom"],true)};
};
dojo.html.getPadBorder=function(node){
var pad=dojo.html.getPadding(node);
var _334=dojo.html.getBorder(node);
return {width:pad.width+_334.width,height:pad.height+_334.height};
};
dojo.html.getBoxSizing=function(node){
var h=dojo.render.html;
var bs=dojo.html.boxSizing;
if(((h.ie)||(h.opera))&&node.nodeName.toLowerCase()!="img"){
var cm=document["compatMode"];
if((cm=="BackCompat")||(cm=="QuirksMode")){
return bs.BORDER_BOX;
}else{
return bs.CONTENT_BOX;
}
}else{
if(arguments.length==0){
node=document.documentElement;
}
var _339;
if(!h.ie){
_339=dojo.html.getStyle(node,"-moz-box-sizing");
if(!_339){
_339=dojo.html.getStyle(node,"box-sizing");
}
}
return (_339?_339:bs.CONTENT_BOX);
}
};
dojo.html.isBorderBox=function(node){
return (dojo.html.getBoxSizing(node)==dojo.html.boxSizing.BORDER_BOX);
};
dojo.html.getBorderBox=function(node){
node=dojo.byId(node);
return {width:node.offsetWidth,height:node.offsetHeight};
};
dojo.html.getPaddingBox=function(node){
var box=dojo.html.getBorderBox(node);
var _33e=dojo.html.getBorder(node);
return {width:box.width-_33e.width,height:box.height-_33e.height};
};
dojo.html.getContentBox=function(node){
node=dojo.byId(node);
var _340=dojo.html.getPadBorder(node);
return {width:node.offsetWidth-_340.width,height:node.offsetHeight-_340.height};
};
dojo.html.setContentBox=function(node,args){
node=dojo.byId(node);
var _343=0;
var _344=0;
var isbb=dojo.html.isBorderBox(node);
var _346=(isbb?dojo.html.getPadBorder(node):{width:0,height:0});
var ret={};
if(typeof args.width!="undefined"){
_343=args.width+_346.width;
ret.width=dojo.html.setPositivePixelValue(node,"width",_343);
}
if(typeof args.height!="undefined"){
_344=args.height+_346.height;
ret.height=dojo.html.setPositivePixelValue(node,"height",_344);
}
return ret;
};
dojo.html.getMarginBox=function(node){
var _349=dojo.html.getBorderBox(node);
var _34a=dojo.html.getMargin(node);
return {width:_349.width+_34a.width,height:_349.height+_34a.height};
};
dojo.html.setMarginBox=function(node,args){
node=dojo.byId(node);
var _34d=0;
var _34e=0;
var isbb=dojo.html.isBorderBox(node);
var _350=(!isbb?dojo.html.getPadBorder(node):{width:0,height:0});
var _351=dojo.html.getMargin(node);
var ret={};
if(typeof args.width!="undefined"){
_34d=args.width-_350.width;
_34d-=_351.width;
ret.width=dojo.html.setPositivePixelValue(node,"width",_34d);
}
if(typeof args.height!="undefined"){
_34e=args.height-_350.height;
_34e-=_351.height;
ret.height=dojo.html.setPositivePixelValue(node,"height",_34e);
}
return ret;
};
dojo.html.getElementBox=function(node,type){
var bs=dojo.html.boxSizing;
switch(type){
case bs.MARGIN_BOX:
return dojo.html.getMarginBox(node);
case bs.BORDER_BOX:
return dojo.html.getBorderBox(node);
case bs.PADDING_BOX:
return dojo.html.getPaddingBox(node);
case bs.CONTENT_BOX:
default:
return dojo.html.getContentBox(node);
}
};
dojo.html.toCoordinateObject=dojo.html.toCoordinateArray=function(_356,_357,_358){
if(_356 instanceof Array||typeof _356=="array"){
dojo.deprecated("dojo.html.toCoordinateArray","use dojo.html.toCoordinateObject({left: , top: , width: , height: }) instead","0.5");
while(_356.length<4){
_356.push(0);
}
while(_356.length>4){
_356.pop();
}
var ret={left:_356[0],top:_356[1],width:_356[2],height:_356[3]};
}else{
if(!_356.nodeType&&!(_356 instanceof String||typeof _356=="string")&&("width" in _356||"height" in _356||"left" in _356||"x" in _356||"top" in _356||"y" in _356)){
var ret={left:_356.left||_356.x||0,top:_356.top||_356.y||0,width:_356.width||0,height:_356.height||0};
}else{
var node=dojo.byId(_356);
var pos=dojo.html.abs(node,_357,_358);
var _35c=dojo.html.getMarginBox(node);
var ret={left:pos.left,top:pos.top,width:_35c.width,height:_35c.height};
}
}
ret.x=ret.left;
ret.y=ret.top;
return ret;
};
dojo.html.setMarginBoxWidth=dojo.html.setOuterWidth=function(node,_35e){
return dojo.html._callDeprecated("setMarginBoxWidth","setMarginBox",arguments,"width");
};
dojo.html.setMarginBoxHeight=dojo.html.setOuterHeight=function(){
return dojo.html._callDeprecated("setMarginBoxHeight","setMarginBox",arguments,"height");
};
dojo.html.getMarginBoxWidth=dojo.html.getOuterWidth=function(){
return dojo.html._callDeprecated("getMarginBoxWidth","getMarginBox",arguments,null,"width");
};
dojo.html.getMarginBoxHeight=dojo.html.getOuterHeight=function(){
return dojo.html._callDeprecated("getMarginBoxHeight","getMarginBox",arguments,null,"height");
};
dojo.html.getTotalOffset=function(node,type,_361){
return dojo.html._callDeprecated("getTotalOffset","getAbsolutePosition",arguments,null,type);
};
dojo.html.getAbsoluteX=function(node,_363){
return dojo.html._callDeprecated("getAbsoluteX","getAbsolutePosition",arguments,null,"x");
};
dojo.html.getAbsoluteY=function(node,_365){
return dojo.html._callDeprecated("getAbsoluteY","getAbsolutePosition",arguments,null,"y");
};
dojo.html.totalOffsetLeft=function(node,_367){
return dojo.html._callDeprecated("totalOffsetLeft","getAbsolutePosition",arguments,null,"left");
};
dojo.html.totalOffsetTop=function(node,_369){
return dojo.html._callDeprecated("totalOffsetTop","getAbsolutePosition",arguments,null,"top");
};
dojo.html.getMarginWidth=function(node){
return dojo.html._callDeprecated("getMarginWidth","getMargin",arguments,null,"width");
};
dojo.html.getMarginHeight=function(node){
return dojo.html._callDeprecated("getMarginHeight","getMargin",arguments,null,"height");
};
dojo.html.getBorderWidth=function(node){
return dojo.html._callDeprecated("getBorderWidth","getBorder",arguments,null,"width");
};
dojo.html.getBorderHeight=function(node){
return dojo.html._callDeprecated("getBorderHeight","getBorder",arguments,null,"height");
};
dojo.html.getPaddingWidth=function(node){
return dojo.html._callDeprecated("getPaddingWidth","getPadding",arguments,null,"width");
};
dojo.html.getPaddingHeight=function(node){
return dojo.html._callDeprecated("getPaddingHeight","getPadding",arguments,null,"height");
};
dojo.html.getPadBorderWidth=function(node){
return dojo.html._callDeprecated("getPadBorderWidth","getPadBorder",arguments,null,"width");
};
dojo.html.getPadBorderHeight=function(node){
return dojo.html._callDeprecated("getPadBorderHeight","getPadBorder",arguments,null,"height");
};
dojo.html.getBorderBoxWidth=dojo.html.getInnerWidth=function(){
return dojo.html._callDeprecated("getBorderBoxWidth","getBorderBox",arguments,null,"width");
};
dojo.html.getBorderBoxHeight=dojo.html.getInnerHeight=function(){
return dojo.html._callDeprecated("getBorderBoxHeight","getBorderBox",arguments,null,"height");
};
dojo.html.getContentBoxWidth=dojo.html.getContentWidth=function(){
return dojo.html._callDeprecated("getContentBoxWidth","getContentBox",arguments,null,"width");
};
dojo.html.getContentBoxHeight=dojo.html.getContentHeight=function(){
return dojo.html._callDeprecated("getContentBoxHeight","getContentBox",arguments,null,"height");
};
dojo.html.setContentBoxWidth=dojo.html.setContentWidth=function(node,_373){
return dojo.html._callDeprecated("setContentBoxWidth","setContentBox",arguments,"width");
};
dojo.html.setContentBoxHeight=dojo.html.setContentHeight=function(node,_375){
return dojo.html._callDeprecated("setContentBoxHeight","setContentBox",arguments,"height");
};
dojo.provide("dojo.lfx.html");
dojo.lfx.html._byId=function(_376){
if(!_376){
return [];
}
if(dojo.lang.isArrayLike(_376)){
if(!_376.alreadyChecked){
var n=[];
dojo.lang.forEach(_376,function(node){
n.push(dojo.byId(node));
});
n.alreadyChecked=true;
return n;
}else{
return _376;
}
}else{
var n=[];
n.push(dojo.byId(_376));
n.alreadyChecked=true;
return n;
}
};
dojo.lfx.html.propertyAnimation=function(_379,_37a,_37b,_37c,_37d){
_379=dojo.lfx.html._byId(_379);
var _37e={"propertyMap":_37a,"nodes":_379,"duration":_37b,"easing":_37c||dojo.lfx.easeDefault};
var _37f=function(args){
if(args.nodes.length==1){
var pm=args.propertyMap;
if(!dojo.lang.isArray(args.propertyMap)){
var parr=[];
for(var _383 in pm){
pm[_383].property=_383;
parr.push(pm[_383]);
}
pm=args.propertyMap=parr;
}
dojo.lang.forEach(pm,function(prop){
if(dj_undef("start",prop)){
if(prop.property!="opacity"){
prop.start=parseInt(dojo.html.getComputedStyle(args.nodes[0],prop.property));
}else{
prop.start=dojo.html.getOpacity(args.nodes[0]);
}
}
});
}
};
var _385=function(_386){
var _387=[];
dojo.lang.forEach(_386,function(c){
_387.push(Math.round(c));
});
return _387;
};
var _389=function(n,_38b){
n=dojo.byId(n);
if(!n||!n.style){
return;
}
for(var s in _38b){
try{
if(s=="opacity"){
dojo.html.setOpacity(n,_38b[s]);
}else{
n.style[s]=_38b[s];
}
}
catch(e){
dojo.debug(e);
}
}
};
var _38d=function(_38e){
this._properties=_38e;
this.diffs=new Array(_38e.length);
dojo.lang.forEach(_38e,function(prop,i){
if(dojo.lang.isFunction(prop.start)){
prop.start=prop.start(prop,i);
}
if(dojo.lang.isFunction(prop.end)){
prop.end=prop.end(prop,i);
}
if(dojo.lang.isArray(prop.start)){
this.diffs[i]=null;
}else{
if(prop.start instanceof dojo.gfx.color.Color){
prop.startRgb=prop.start.toRgb();
prop.endRgb=prop.end.toRgb();
}else{
this.diffs[i]=prop.end-prop.start;
}
}
},this);
this.getValue=function(n){
var ret={};
dojo.lang.forEach(this._properties,function(prop,i){
var _395=null;
if(dojo.lang.isArray(prop.start)){
}else{
if(prop.start instanceof dojo.gfx.color.Color){
_395=(prop.units||"rgb")+"(";
for(var j=0;j<prop.startRgb.length;j++){
_395+=Math.round(((prop.endRgb[j]-prop.startRgb[j])*n)+prop.startRgb[j])+(j<prop.startRgb.length-1?",":"");
}
_395+=")";
}else{
_395=((this.diffs[i])*n)+prop.start+(prop.property!="opacity"?prop.units||"px":"");
}
}
ret[dojo.html.toCamelCase(prop.property)]=_395;
},this);
return ret;
};
};
var anim=new dojo.lfx.Animation({beforeBegin:function(){
_37f(_37e);
anim.curve=new _38d(_37e.propertyMap);
},onAnimate:function(_398){
dojo.lang.forEach(_37e.nodes,function(node){
_389(node,_398);
});
}},_37e.duration,null,_37e.easing);
if(_37d){
for(var x in _37d){
if(dojo.lang.isFunction(_37d[x])){
anim.connect(x,anim,_37d[x]);
}
}
}
return anim;
};
dojo.lfx.html._makeFadeable=function(_39b){
var _39c=function(node){
if(dojo.render.html.ie){
if((node.style.zoom.length==0)&&(dojo.html.getStyle(node,"zoom")=="normal")){
node.style.zoom="1";
}
if((node.style.width.length==0)&&(dojo.html.getStyle(node,"width")=="auto")){
node.style.width="auto";
}
}
};
if(dojo.lang.isArrayLike(_39b)){
dojo.lang.forEach(_39b,_39c);
}else{
_39c(_39b);
}
};
dojo.lfx.html.fade=function(_39e,_39f,_3a0,_3a1,_3a2){
_39e=dojo.lfx.html._byId(_39e);
var _3a3={property:"opacity"};
if(!dj_undef("start",_39f)){
_3a3.start=_39f.start;
}else{
_3a3.start=function(){
return dojo.html.getOpacity(_39e[0]);
};
}
if(!dj_undef("end",_39f)){
_3a3.end=_39f.end;
}else{
dojo.raise("dojo.lfx.html.fade needs an end value");
}
var anim=dojo.lfx.propertyAnimation(_39e,[_3a3],_3a0,_3a1);
anim.connect("beforeBegin",function(){
dojo.lfx.html._makeFadeable(_39e);
});
if(_3a2){
anim.connect("onEnd",function(){
_3a2(_39e,anim);
});
}
return anim;
};
dojo.lfx.html.fadeIn=function(_3a5,_3a6,_3a7,_3a8){
return dojo.lfx.html.fade(_3a5,{end:1},_3a6,_3a7,_3a8);
};
dojo.lfx.html.fadeOut=function(_3a9,_3aa,_3ab,_3ac){
return dojo.lfx.html.fade(_3a9,{end:0},_3aa,_3ab,_3ac);
};
dojo.lfx.html.fadeShow=function(_3ad,_3ae,_3af,_3b0){
_3ad=dojo.lfx.html._byId(_3ad);
dojo.lang.forEach(_3ad,function(node){
dojo.html.setOpacity(node,0);
});
var anim=dojo.lfx.html.fadeIn(_3ad,_3ae,_3af,_3b0);
anim.connect("beforeBegin",function(){
if(dojo.lang.isArrayLike(_3ad)){
dojo.lang.forEach(_3ad,dojo.html.show);
}else{
dojo.html.show(_3ad);
}
});
return anim;
};
dojo.lfx.html.fadeHide=function(_3b3,_3b4,_3b5,_3b6){
var anim=dojo.lfx.html.fadeOut(_3b3,_3b4,_3b5,function(){
if(dojo.lang.isArrayLike(_3b3)){
dojo.lang.forEach(_3b3,dojo.html.hide);
}else{
dojo.html.hide(_3b3);
}
if(_3b6){
_3b6(_3b3,anim);
}
});
return anim;
};
dojo.lfx.html.wipeIn=function(_3b8,_3b9,_3ba,_3bb){
_3b8=dojo.lfx.html._byId(_3b8);
var _3bc=[];
dojo.lang.forEach(_3b8,function(node){
var _3be={};
var _3bf,_3c0,_3c1;
with(node.style){
_3bf=top;
_3c0=left;
_3c1=position;
top="-9999px";
left="-9999px";
position="absolute";
display="";
}
var _3c2=dojo.html.getBorderBox(node).height;
with(node.style){
top=_3bf;
left=_3c0;
position=_3c1;
display="none";
}
var anim=dojo.lfx.propertyAnimation(node,{"height":{start:1,end:function(){
return _3c2;
}}},_3b9,_3ba);
anim.connect("beforeBegin",function(){
_3be.overflow=node.style.overflow;
_3be.height=node.style.height;
with(node.style){
overflow="hidden";
height="1px";
}
dojo.html.show(node);
});
anim.connect("onEnd",function(){
with(node.style){
overflow=_3be.overflow;
height=_3be.height;
}
if(_3bb){
_3bb(node,anim);
}
});
_3bc.push(anim);
});
return dojo.lfx.combine(_3bc);
};
dojo.lfx.html.wipeOut=function(_3c4,_3c5,_3c6,_3c7){
_3c4=dojo.lfx.html._byId(_3c4);
var _3c8=[];
dojo.lang.forEach(_3c4,function(node){
var _3ca={};
var anim=dojo.lfx.propertyAnimation(node,{"height":{start:function(){
return dojo.html.getContentBox(node).height;
},end:1}},_3c5,_3c6,{"beforeBegin":function(){
_3ca.overflow=node.style.overflow;
_3ca.height=node.style.height;
with(node.style){
overflow="hidden";
}
dojo.html.show(node);
},"onEnd":function(){
dojo.html.hide(node);
with(node.style){
overflow=_3ca.overflow;
height=_3ca.height;
}
if(_3c7){
_3c7(node,anim);
}
}});
_3c8.push(anim);
});
return dojo.lfx.combine(_3c8);
};
dojo.lfx.html.slideTo=function(_3cc,_3cd,_3ce,_3cf,_3d0){
_3cc=dojo.lfx.html._byId(_3cc);
var _3d1=[];
var _3d2=dojo.html.getComputedStyle;
if(dojo.lang.isArray(_3cd)){
dojo.deprecated("dojo.lfx.html.slideTo(node, array)","use dojo.lfx.html.slideTo(node, {top: value, left: value});","0.5");
_3cd={top:_3cd[0],left:_3cd[1]};
}
dojo.lang.forEach(_3cc,function(node){
var top=null;
var left=null;
var init=(function(){
var _3d7=node;
return function(){
var pos=_3d2(_3d7,"position");
top=(pos=="absolute"?node.offsetTop:parseInt(_3d2(node,"top"))||0);
left=(pos=="absolute"?node.offsetLeft:parseInt(_3d2(node,"left"))||0);
if(!dojo.lang.inArray(["absolute","relative"],pos)){
var ret=dojo.html.abs(_3d7,true);
dojo.html.setStyleAttributes(_3d7,"position:absolute;top:"+ret.y+"px;left:"+ret.x+"px;");
top=ret.y;
left=ret.x;
}
};
})();
init();
var anim=dojo.lfx.propertyAnimation(node,{"top":{start:top,end:(_3cd.top||0)},"left":{start:left,end:(_3cd.left||0)}},_3ce,_3cf,{"beforeBegin":init});
if(_3d0){
anim.connect("onEnd",function(){
_3d0(_3cc,anim);
});
}
_3d1.push(anim);
});
return dojo.lfx.combine(_3d1);
};
dojo.lfx.html.slideBy=function(_3db,_3dc,_3dd,_3de,_3df){
_3db=dojo.lfx.html._byId(_3db);
var _3e0=[];
var _3e1=dojo.html.getComputedStyle;
if(dojo.lang.isArray(_3dc)){
dojo.deprecated("dojo.lfx.html.slideBy(node, array)","use dojo.lfx.html.slideBy(node, {top: value, left: value});","0.5");
_3dc={top:_3dc[0],left:_3dc[1]};
}
dojo.lang.forEach(_3db,function(node){
var top=null;
var left=null;
var init=(function(){
var _3e6=node;
return function(){
var pos=_3e1(_3e6,"position");
top=(pos=="absolute"?node.offsetTop:parseInt(_3e1(node,"top"))||0);
left=(pos=="absolute"?node.offsetLeft:parseInt(_3e1(node,"left"))||0);
if(!dojo.lang.inArray(["absolute","relative"],pos)){
var ret=dojo.html.abs(_3e6,true);
dojo.html.setStyleAttributes(_3e6,"position:absolute;top:"+ret.y+"px;left:"+ret.x+"px;");
top=ret.y;
left=ret.x;
}
};
})();
init();
var anim=dojo.lfx.propertyAnimation(node,{"top":{start:top,end:top+(_3dc.top||0)},"left":{start:left,end:left+(_3dc.left||0)}},_3dd,_3de).connect("beforeBegin",init);
if(_3df){
anim.connect("onEnd",function(){
_3df(_3db,anim);
});
}
_3e0.push(anim);
});
return dojo.lfx.combine(_3e0);
};
dojo.lfx.html.explode=function(_3ea,_3eb,_3ec,_3ed,_3ee){
var h=dojo.html;
_3ea=dojo.byId(_3ea);
_3eb=dojo.byId(_3eb);
var _3f0=h.toCoordinateObject(_3ea,true);
var _3f1=document.createElement("div");
h.copyStyle(_3f1,_3eb);
if(_3eb.explodeClassName){
_3f1.className=_3eb.explodeClassName;
}
with(_3f1.style){
position="absolute";
display="none";
var _3f2=h.getStyle(_3ea,"background-color");
backgroundColor=_3f2?_3f2.toLowerCase():"transparent";
backgroundColor=(backgroundColor=="transparent")?"rgb(221, 221, 221)":backgroundColor;
}
dojo.body().appendChild(_3f1);
with(_3eb.style){
visibility="hidden";
display="block";
}
var _3f3=h.toCoordinateObject(_3eb,true);
with(_3eb.style){
display="none";
visibility="visible";
}
var _3f4={opacity:{start:0.5,end:1}};
dojo.lang.forEach(["height","width","top","left"],function(type){
_3f4[type]={start:_3f0[type],end:_3f3[type]};
});
var anim=new dojo.lfx.propertyAnimation(_3f1,_3f4,_3ec,_3ed,{"beforeBegin":function(){
h.setDisplay(_3f1,"block");
},"onEnd":function(){
h.setDisplay(_3eb,"block");
_3f1.parentNode.removeChild(_3f1);
}});
if(_3ee){
anim.connect("onEnd",function(){
_3ee(_3eb,anim);
});
}
return anim;
};
dojo.lfx.html.implode=function(_3f7,end,_3f9,_3fa,_3fb){
var h=dojo.html;
_3f7=dojo.byId(_3f7);
end=dojo.byId(end);
var _3fd=dojo.html.toCoordinateObject(_3f7,true);
var _3fe=dojo.html.toCoordinateObject(end,true);
var _3ff=document.createElement("div");
dojo.html.copyStyle(_3ff,_3f7);
if(_3f7.explodeClassName){
_3ff.className=_3f7.explodeClassName;
}
dojo.html.setOpacity(_3ff,0.3);
with(_3ff.style){
position="absolute";
display="none";
backgroundColor=h.getStyle(_3f7,"background-color").toLowerCase();
}
dojo.body().appendChild(_3ff);
var _400={opacity:{start:1,end:0.5}};
dojo.lang.forEach(["height","width","top","left"],function(type){
_400[type]={start:_3fd[type],end:_3fe[type]};
});
var anim=new dojo.lfx.propertyAnimation(_3ff,_400,_3f9,_3fa,{"beforeBegin":function(){
dojo.html.hide(_3f7);
dojo.html.show(_3ff);
},"onEnd":function(){
_3ff.parentNode.removeChild(_3ff);
}});
if(_3fb){
anim.connect("onEnd",function(){
_3fb(_3f7,anim);
});
}
return anim;
};
dojo.lfx.html.highlight=function(_403,_404,_405,_406,_407){
_403=dojo.lfx.html._byId(_403);
var _408=[];
dojo.lang.forEach(_403,function(node){
var _40a=dojo.html.getBackgroundColor(node);
var bg=dojo.html.getStyle(node,"background-color").toLowerCase();
var _40c=dojo.html.getStyle(node,"background-image");
var _40d=(bg=="transparent"||bg=="rgba(0, 0, 0, 0)");
while(_40a.length>3){
_40a.pop();
}
var rgb=new dojo.gfx.color.Color(_404);
var _40f=new dojo.gfx.color.Color(_40a);
var anim=dojo.lfx.propertyAnimation(node,{"background-color":{start:rgb,end:_40f}},_405,_406,{"beforeBegin":function(){
if(_40c){
node.style.backgroundImage="none";
}
node.style.backgroundColor="rgb("+rgb.toRgb().join(",")+")";
},"onEnd":function(){
if(_40c){
node.style.backgroundImage=_40c;
}
if(_40d){
node.style.backgroundColor="transparent";
}
if(_407){
_407(node,anim);
}
}});
_408.push(anim);
});
return dojo.lfx.combine(_408);
};
dojo.lfx.html.unhighlight=function(_411,_412,_413,_414,_415){
_411=dojo.lfx.html._byId(_411);
var _416=[];
dojo.lang.forEach(_411,function(node){
var _418=new dojo.gfx.color.Color(dojo.html.getBackgroundColor(node));
var rgb=new dojo.gfx.color.Color(_412);
var _41a=dojo.html.getStyle(node,"background-image");
var anim=dojo.lfx.propertyAnimation(node,{"background-color":{start:_418,end:rgb}},_413,_414,{"beforeBegin":function(){
if(_41a){
node.style.backgroundImage="none";
}
node.style.backgroundColor="rgb("+_418.toRgb().join(",")+")";
},"onEnd":function(){
if(_415){
_415(node,anim);
}
}});
_416.push(anim);
});
return dojo.lfx.combine(_416);
};
dojo.lang.mixin(dojo.lfx,dojo.lfx.html);

